PATH:
usr
/
bin
#!/usr/bin/bash KEXEC=/sbin/kexec KDUMP_KERNELVER="" KDUMP_KERNEL="" KDUMP_COMMANDLINE="" KEXEC_ARGS="" MKDUMPRD="/sbin/mkdumprd -f" MKFADUMPRD="/sbin/mkfadumprd" DRACUT_MODULES_FILE="/usr/lib/dracut/modules.txt" SAVE_PATH=/var/crash SSH_KEY_LOCATION="/root/.ssh/kdump_id_rsa" DUMP_TARGET="" DEFAULT_INITRD="" DEFAULT_INITRD_BAK="" INITRD_CHECKSUM_LOCATION="" KDUMP_INITRD="" TARGET_INITRD="" #kdump shall be the default dump mode DEFAULT_DUMP_MODE="kdump" VMCORE_CREATION_STATUS="/var/lib/kdump/vmcore-creation.status" image_time=0 standard_kexec_args="-p" # Some default values in case /etc/sysconfig/kdump doesn't include KDUMP_COMMANDLINE_REMOVE="hugepages hugepagesz slub_debug" if [[ -f /etc/sysconfig/kdump ]]; then . /etc/sysconfig/kdump fi [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut . $dracutbasedir/dracut-functions.sh . /lib/kdump/kdump-lib.sh . /lib/kdump/kdump-logger.sh #initiate the kdump logger if ! dlog_init; then echo "failed to initiate the kdump logger." exit 1 fi KDUMP_TMPDIR=$(mktemp --tmpdir -d kdump.XXXX) TMPMNT="$KDUMP_TMPDIR/target" trap ' ret=$?; is_mounted $TMPMNT && umount -f $TMPMNT; rm -rf "$KDUMP_TMPDIR" exit $ret; ' EXIT single_instance_lock() { local rc timeout=5 lockfile if [[ -d /run/lock ]]; then lockfile=/run/lock/kdump else # when updating package using virt-customize, /run/lock doesn't exist lockfile=/tmp/kdump.lock fi if ! exec 9> $lockfile; then derror "Create file lock failed" exit 1 fi flock -n 9 rc=$? while [[ $rc -ne 0 ]]; do dinfo "Another app is currently holding the kdump lock; waiting for it to exit..." flock -w $timeout 9 rc=$? done } determine_dump_mode() { # Check if firmware-assisted dump is enabled # if yes, set the dump mode as fadump if is_fadump_capable; then dinfo "Dump mode is fadump" DEFAULT_DUMP_MODE="fadump" fi ddebug "DEFAULT_DUMP_MODE=$DEFAULT_DUMP_MODE" } save_core() { coredir="/var/crash/$(date +"%Y-%m-%d-%H:%M")" mkdir -p "$coredir" ddebug "cp --sparse=always /proc/vmcore $coredir/vmcore-incomplete" if cp --sparse=always /proc/vmcore "$coredir/vmcore-incomplete"; then mv "$coredir/vmcore-incomplete" "$coredir/vmcore" dinfo "saved a vmcore to $coredir" else derror "failed to save a vmcore to $coredir" fi # pass the dmesg to Abrt tool if exists, in order # to collect the kernel oops message. # https://fedorahosted.org/abrt/ if [[ -x /usr/bin/dumpoops ]]; then ddebug "makedumpfile --dump-dmesg $coredir/vmcore $coredir/dmesg" makedumpfile --dump-dmesg "$coredir/vmcore" "$coredir/dmesg" > /dev/null 2>&1 ddebug "dumpoops -d $coredir/dmesg" if dumpoops -d "$coredir/dmesg" > /dev/null 2>&1; then dinfo "kernel oops has been collected by abrt tool" fi fi } rebuild_fadump_initrd() { if ! $MKFADUMPRD "$DEFAULT_INITRD_BAK" "$TARGET_INITRD" --kver "$KDUMP_KERNELVER"; then derror "mkfadumprd: failed to make fadump initrd" return 1 fi return 0 } check_earlykdump_is_enabled() { grep -q -w "rd.earlykdump" /proc/cmdline } rebuild_kdump_initrd() { ddebug "rebuild kdump initrd: $MKDUMPRD $TARGET_INITRD $KDUMP_KERNELVER" if ! $MKDUMPRD "$TARGET_INITRD" "$KDUMP_KERNELVER"; then derror "mkdumprd: failed to make kdump initrd" return 1 fi if check_earlykdump_is_enabled; then dwarn "Tips: If early kdump is enabled, also require rebuilding the system initramfs to make the changes take effect for early kdump." fi return 0 } check_and_generate_vconsole_conf() { if [[ ! -e /etc/vconsole.conf ]]; then dwarn "/etc/vconsole.conf does not exist, trying to set keymap to us to reduce the initramfs size." if [[ -x "$(command -v localectl)" ]] ; then if localectl list-keymaps | grep -q "^us$"; then localectl set-keymap us 2>/dev/null fi fi fi } rebuild_initrd() { local _ret if [[ ! -w $(dirname "$TARGET_INITRD") ]]; then derror "$(dirname "$TARGET_INITRD") does not have write permission. Cannot rebuild $TARGET_INITRD" return 1 fi check_and_generate_vconsole_conf if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then rebuild_fadump_initrd else rebuild_kdump_initrd fi _ret=$? set_vmcore_creation_status 'clear' return $_ret } #$1: the files to be checked with IFS=' ' check_exist() { for file in $1; do if [[ ! -e $file ]]; then derror "Error: $file not found." return 1 fi done } #$1: the files to be checked with IFS=' ' check_executable() { for file in $1; do if [[ ! -x $file ]]; then derror "Error: $file is not executable." return 1 fi done } backup_default_initrd() { ddebug "backup default initrd: $DEFAULT_INITRD" if [[ ! -f $DEFAULT_INITRD ]]; then return fi if [[ ! -e $DEFAULT_INITRD_BAK ]]; then dinfo "Backing up $DEFAULT_INITRD before rebuild." # save checksum to verify before restoring sha1sum "$DEFAULT_INITRD" > "$INITRD_CHECKSUM_LOCATION" if ! cp "$DEFAULT_INITRD" "$DEFAULT_INITRD_BAK"; then dwarn "WARNING: failed to backup $DEFAULT_INITRD." rm -f -- "$INITRD_CHECKSUM_LOCATION" rm -f -- "$DEFAULT_INITRD_BAK" fi fi } restore_default_initrd() { ddebug "restore default initrd: $DEFAULT_INITRD" if [[ ! -f $DEFAULT_INITRD ]]; then return fi # If a backup initrd exists, we must be switching back from # fadump to kdump. Restore the original default initrd. if [[ -f $DEFAULT_INITRD_BAK ]] && [[ -f $INITRD_CHECKSUM_LOCATION ]]; then # verify checksum before restoring backup_checksum=$(sha1sum "$DEFAULT_INITRD_BAK" | awk '{ print $1 }') default_checksum=$(awk '{ print $1 }' "$INITRD_CHECKSUM_LOCATION") if [[ $default_checksum != "$backup_checksum" ]]; then dwarn "WARNING: checksum mismatch! Can't restore original initrd.." else rm -f $INITRD_CHECKSUM_LOCATION if mv "$DEFAULT_INITRD_BAK" "$DEFAULT_INITRD"; then derror "Restoring original initrd as fadump mode is disabled." sync fi fi fi } check_config() { local -A _opt_rec while read -r config_opt config_val; do case "$config_opt" in dracut_args) if [[ $config_val == *--mount* ]]; then if [[ $(echo "$config_val" | grep -o "\-\-mount" | wc -l) -ne 1 ]]; then derror 'Multiple mount targets specified in one "dracut_args".' return 1 fi config_opt=_target fi ;; raw) if [[ -d "/proc/device-tree/ibm,opal/dump" ]]; then dwarn "WARNING: Won't capture opalcore when 'raw' dump target is used." fi config_opt=_target ;; ext[234] | minix | btrfs | xfs | nfs | ssh | virtiofs) config_opt=_target ;; sshkey | path | core_collector | kdump_post | kdump_pre | extra_bins | extra_modules | failure_action | default | final_action | force_rebuild | force_no_rebuild | fence_kdump_args | fence_kdump_nodes | auto_reset_crashkernel) ;; net | options | link_delay | disk_timeout | debug_mem_level | blacklist) derror "Deprecated kdump config option: $config_opt. Refer to kdump.conf manpage for alternatives." return 1 ;; '') continue ;; *) derror "Invalid kdump config option $config_opt" return 1 ;; esac if [[ -z $config_val ]]; then derror "Invalid kdump config value for option '$config_opt'" return 1 fi if [[ -n ${_opt_rec[$config_opt]} ]]; then if [[ $config_opt == _target ]]; then derror "More than one dump targets specified" else derror "Duplicated kdump config value of option $config_opt" fi return 1 fi _opt_rec[$config_opt]="$config_val" done <<< "$(kdump_read_conf)" check_failure_action_config || return 1 check_final_action_config || return 1 check_fence_kdump_config || return 1 return 0 } # get_pcs_cluster_modified_files <image timestamp> # return list of modified file for fence_kdump modified in Pacemaker cluster get_pcs_cluster_modified_files() { local time_stamp local modified_files is_generic_fence_kdump && return 1 is_pcs_fence_kdump || return 1 time_stamp=$(pcs cluster cib | xmllint --xpath 'string(/cib/@cib-last-written)' - | xargs -0 date +%s --date) if [[ -n $time_stamp ]] && [[ $time_stamp -gt $image_time ]]; then modified_files="cluster-cib" fi if [[ -f $FENCE_KDUMP_CONFIG_FILE ]]; then time_stamp=$(stat -c "%Y" "$FENCE_KDUMP_CONFIG_FILE") if [[ $time_stamp -gt $image_time ]]; then modified_files="$modified_files $FENCE_KDUMP_CONFIG_FILE" fi fi echo "$modified_files" } setup_initrd() { if ! prepare_kdump_bootinfo; then derror "failed to prepare for kdump bootinfo." return 1 fi DEFAULT_INITRD_BAK="$KDUMP_BOOTDIR/.$(basename "$DEFAULT_INITRD").default" INITRD_CHECKSUM_LOCATION="$DEFAULT_INITRD_BAK.checksum" if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then TARGET_INITRD="$DEFAULT_INITRD" # backup initrd for reference before replacing it # with fadump aware initrd backup_default_initrd else TARGET_INITRD="$KDUMP_INITRD" # check if a backup of default initrd exists. If yes, # it signifies a switch from fadump mode. So, restore # the backed up default initrd. restore_default_initrd fi } check_files_modified() { local modified_files="" #also rebuild when Pacemaker cluster conf is changed and fence kdump is enabled. modified_files=$(get_pcs_cluster_modified_files) EXTRA_BINS=$(kdump_get_conf_val kdump_post) CHECK_FILES=$(kdump_get_conf_val kdump_pre) HOOKS="/etc/kdump/post.d/ /etc/kdump/pre.d/" if [[ -d /etc/kdump/post.d ]]; then for file in /etc/kdump/post.d/*; do if [[ -x $file ]]; then POST_FILES="$POST_FILES $file" fi done fi if [[ -d /etc/kdump/pre.d ]]; then for file in /etc/kdump/pre.d/*; do if [[ -x $file ]]; then PRE_FILES="$PRE_FILES $file" fi done fi HOOKS="$HOOKS $POST_FILES $PRE_FILES" CORE_COLLECTOR=$(kdump_get_conf_val core_collector | awk '{print $1}') CORE_COLLECTOR=$(type -P "$CORE_COLLECTOR") # POST_FILES and PRE_FILES are already checked against executable, need not to check again. EXTRA_BINS="$EXTRA_BINS $CHECK_FILES" CHECK_FILES=$(kdump_get_conf_val extra_bins) EXTRA_BINS="$EXTRA_BINS $CHECK_FILES" files="$KDUMP_CONFIG_FILE $KDUMP_KERNEL $EXTRA_BINS $CORE_COLLECTOR" [[ -e /etc/fstab ]] && files="$files /etc/fstab" # Check for any updated extra module EXTRA_MODULES="$(kdump_get_conf_val extra_modules)" if [[ -n $EXTRA_MODULES ]]; then if [[ -e /lib/modules/$KDUMP_KERNELVER/modules.dep ]]; then files="$files /lib/modules/$KDUMP_KERNELVER/modules.dep" fi for _module in $EXTRA_MODULES; do if _module_file="$(modinfo --set-version "$KDUMP_KERNELVER" --filename "$_module" 2> /dev/null)"; then files="$files $_module_file" for _dep_modules in $(modinfo -F depends "$_module" | tr ',' ' '); do files="$files $(modinfo --set-version "$KDUMP_KERNELVER" --filename "$_dep_modules" 2> /dev/null)" done else # If it's not a module nor builtin, give an error if ! (modprobe --set-version "$KDUMP_KERNELVER" --dry-run "$_module" &> /dev/null); then dwarn "Module $_module not found" fi fi done fi # HOOKS is mandatory and need to check the modification time files="$files $HOOKS" is_lvm2_thinp_dump_target && files="$files $LVM_CONF" check_exist "$files" && check_executable "$EXTRA_BINS" || return 2 for file in $files; do if [[ -e $file ]]; then time_stamp=$(stat -c "%Y" "$file") if [[ $time_stamp -gt $image_time ]]; then modified_files="$modified_files $file" fi if [[ -L $file ]]; then file=$(readlink -m "$file") time_stamp=$(stat -c "%Y" "$file") if [[ $time_stamp -gt $image_time ]]; then modified_files="$modified_files $file" fi fi else dwarn "$file doesn't exist" fi done if [[ -n $modified_files ]]; then dinfo "Detected change(s) in the following file(s): $modified_files" return 1 fi return 0 } check_drivers_modified() { local _target _new_drivers _old_drivers _module_name _module_filename # If it's dump target is on block device, detect the block driver _target=$(get_block_dump_target) if [[ -n $_target ]]; then _record_block_drivers() { local _drivers _drivers=$(udevadm info -a "/dev/block/$1" | sed -n 's/\s*DRIVERS=="\(\S\+\)"/\1/p') for _driver in $_drivers; do if ! [[ " $_new_drivers " == *" $_driver "* ]]; then _new_drivers="$_new_drivers $_driver" fi done ddebug "MAJ:MIN=$1 drivers='$_drivers'" } check_block_and_slaves_all _record_block_drivers "$(get_maj_min "$_target")" fi # Include watchdog drivers if watchdog module is not omitted is_dracut_mod_omitted watchdog || _new_drivers+=" $(get_watchdog_drvs)" [[ -z $_new_drivers ]] && return 0 if is_fadump_capable; then _old_drivers="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/fadump-kernel-modules.txt | tr '\n' ' ')" else _old_drivers="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/hostonly-kernel-modules.txt | tr '\n' ' ')" fi ddebug "Modules required for kdump: '$_new_drivers'" ddebug "Modules included in old initramfs: '$_old_drivers'" for _driver in $_new_drivers; do # Skip deprecated/invalid driver name or built-in module _module_name=$(modinfo --set-version "$KDUMP_KERNELVER" -F name "$_driver" 2> /dev/null) _module_filename=$(modinfo --set-version "$KDUMP_KERNELVER" -n "$_driver" 2> /dev/null) if [[ -z $_module_name ]] || [[ -z $_module_filename ]] || [[ $_module_filename == *"(builtin)"* ]]; then continue fi if ! [[ " $_old_drivers " == *" $_module_name "* ]]; then dinfo "Detected change in block device driver, new loaded module: $_module_name" return 1 fi done } check_fs_modified() { local _old_dev _old_mntpoint _old_fstype local _new_dev _new_mntpoint _new_fstype local _target _dracut_args # No need to check in case of mount target specified via "dracut_args". if is_mount_in_dracut_args; then return 0 fi # No need to check in case of raw target. # Currently we do not check also if ssh/nfs/virtiofs/thinp target is specified if is_ssh_dump_target || is_nfs_dump_target || is_raw_dump_target || is_virtiofs_dump_target || is_lvm2_thinp_dump_target; then return 0 fi _target=$(get_block_dump_target) _new_fstype=$(get_fs_type_from_target "$_target") if [[ -z $_target ]] || [[ -z $_new_fstype ]]; then derror "Dump target is invalid" return 2 fi ddebug "_target=$_target _new_fstype=$_new_fstype" _new_dev=$(kdump_get_persistent_dev "$_target") if [[ -z $_new_dev ]]; then perror "Get persistent device name failed" return 2 fi _new_mntpoint="$(get_kdump_mntpoint_from_target "$_target")" _dracut_args=$(lsinitrd "$TARGET_INITRD" -f usr/lib/dracut/build-parameter.txt) if [[ -z $_dracut_args ]]; then dwarn "Warning: No dracut arguments found in initrd" return 0 fi # if --mount argument present then match old and new target, mount # point and file system. If any of them mismatches then rebuild if echo "$_dracut_args" | grep -q "\-\-mount"; then # shellcheck disable=SC2046 set -- $(echo "$_dracut_args" | awk -F "--mount '" '{print $2}' | cut -d' ' -f1,2,3) _old_dev=$1 _old_mntpoint=$2 _old_fstype=$3 [[ $_new_dev == "$_old_dev" && $_new_mntpoint == "$_old_mntpoint" && $_new_fstype == "$_old_fstype" ]] && return 0 # otherwise rebuild if target device is not a root device else [[ $_target == "$(get_root_fs_device)" ]] && return 0 fi dinfo "Detected change in File System" return 1 } # returns 0 if system is not modified # returns 1 if system is modified # returns 2 if system modification is invalid check_system_modified() { local ret local CONF_ERROR=2 local CONF_MODIFY=1 local CONF_NO_MODIFY=0 local conf_status=$CONF_NO_MODIFY [[ -f $TARGET_INITRD ]] || return 1 for _func in check_files_modified check_fs_modified check_drivers_modified; do $_func ret=$? # return immediately if an error occurred. [[ $ret -eq "$CONF_ERROR" ]] && return "$ret" [[ $ret -eq "$CONF_MODIFY" ]] && { conf_status="$CONF_MODIFY"; } done return $conf_status } check_rebuild() { local capture_capable_initrd="1" local force_rebuild force_no_rebuild local ret system_modified="0" setup_initrd || return 1 force_no_rebuild=$(kdump_get_conf_val force_no_rebuild) force_no_rebuild=${force_no_rebuild:-0} if [[ $force_no_rebuild != "0" ]] && [[ $force_no_rebuild != "1" ]]; then derror "Error: force_no_rebuild value is invalid" return 1 fi force_rebuild=$(kdump_get_conf_val force_rebuild) force_rebuild=${force_rebuild:-0} if [[ $force_rebuild != "0" ]] && [[ $force_rebuild != "1" ]]; then derror "Error: force_rebuild value is invalid" return 1 fi if [[ $force_no_rebuild == "1" && $force_rebuild == "1" ]]; then derror "Error: force_rebuild and force_no_rebuild are enabled simultaneously in kdump.conf" return 1 fi # Will not rebuild kdump initrd if [[ $force_no_rebuild == "1" ]]; then return 0 fi #check to see if dependent files has been modified #since last build of the image file if [[ -f $TARGET_INITRD ]]; then image_time=$(stat -c "%Y" "$TARGET_INITRD" 2> /dev/null) #in case of fadump mode, check whether the default/target #initrd is already built with dump capture capability if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then capture_capable_initrd=$(lsinitrd -f $DRACUT_MODULES_FILE "$TARGET_INITRD" | grep -c -e ^kdumpbase$ -e ^zz-fadumpinit$) fi fi check_system_modified ret=$? if [[ $ret -eq 2 ]]; then return 1 elif [[ $ret -eq 1 ]]; then system_modified="1" fi if [[ $image_time -eq 0 ]]; then dinfo "No kdump initial ramdisk found." elif [[ $capture_capable_initrd == "0" ]]; then dinfo "Rebuild $TARGET_INITRD with dump capture support" elif [[ $force_rebuild != "0" ]]; then dinfo "Force rebuild $TARGET_INITRD" elif [[ $system_modified != "0" ]]; then : else return 0 fi dinfo "Rebuilding $TARGET_INITRD" rebuild_initrd } # On ppc64le LPARs, the keys trusted by firmware do not end up in # .builtin_trusted_keys. So instead, add the key to the .ima keyring function load_kdump_kernel_key() { # this is only called inside is_secure_boot_enforced, # no need to retest # this is only required if DT /ibm,secure-boot is a file. # if it is a dir, we are on OpenPower and don't need this. if ! [[ -f /proc/device-tree/ibm,secure-boot ]]; then return fi keyctl padd asymmetric "" %:.ima < "/usr/share/doc/kernel-keys/$KDUMP_KERNELVER/kernel-signing-ppc.cer" } # Load the kdump kernel specified in /etc/sysconfig/kdump # If none is specified, try to load a kdump kernel with the same version # as the currently running kernel. load_kdump() { local uki KEXEC_ARGS=$(prepare_kexec_args "${KEXEC_ARGS}") KDUMP_COMMANDLINE=$(prepare_cmdline "${KDUMP_COMMANDLINE}" "${KDUMP_COMMANDLINE_REMOVE}" "${KDUMP_COMMANDLINE_APPEND}") if is_uki "$KDUMP_KERNEL"; then uki=$KDUMP_KERNEL KDUMP_KERNEL=$KDUMP_TMPDIR/vmlinuz objcopy -O binary --only-section .linux "$uki" "$KDUMP_KERNEL" sync -f "$KDUMP_KERNEL" # Make sure the temp file has the correct SELinux label. # Otherwise starting the kdump.service will fail. chcon -t boot_t "$KDUMP_KERNEL" fi ddebug "$KEXEC $KEXEC_ARGS $standard_kexec_args --command-line=$KDUMP_COMMANDLINE --initrd=$TARGET_INITRD $KDUMP_KERNEL" # shellcheck disable=SC2086 $KEXEC $KEXEC_ARGS $standard_kexec_args \ --command-line="$KDUMP_COMMANDLINE" \ --initrd="$TARGET_INITRD" "$KDUMP_KERNEL" if [[ $? == 0 ]]; then dinfo "kexec: loaded kdump kernel" return 0 else derror "kexec: failed to load kdump kernel" return 1 fi } check_ssh_config() { local SSH_TARGET while read -r config_opt config_val; do case "$config_opt" in sshkey) # remove inline comments after the end of a directive. if [[ -f $config_val ]]; then # canonicalize the path SSH_KEY_LOCATION=$(/usr/bin/readlink -m "$config_val") else dwarn "WARNING: '$config_val' doesn't exist, using default value '$SSH_KEY_LOCATION'" fi ;; path) SAVE_PATH=$config_val ;; ssh) DUMP_TARGET=$config_val ;; *) ;; esac done <<< "$(kdump_read_conf)" #make sure they've configured kdump.conf for ssh dumps SSH_TARGET=$(echo -n "$DUMP_TARGET" | sed -n '/.*@/p') if [[ -z $SSH_TARGET ]]; then return 1 fi return 0 } # ipv6 host address may takes a long time to be ready. # Instead of checking against ipv6 address, we just check the network reachable # by the return val of 'ssh' check_and_wait_network_ready() { local start_time local warn_once=1 local cur local diff local retval local errmsg start_time=$(date +%s) while true; do errmsg=$(ssh -i "$SSH_KEY_LOCATION" -o BatchMode=yes "$DUMP_TARGET" mkdir -p "$SAVE_PATH" 2>&1) retval=$? # ssh exits with the exit status of the remote command or with 255 if an error occurred if [[ $retval -eq 0 ]]; then return 0 elif [[ $retval -ne 255 ]]; then derror "Could not create $DUMP_TARGET:$SAVE_PATH, you should check the privilege on server side" return 1 fi # if server removes the authorized_keys or, no /root/.ssh/kdump_id_rsa ddebug "$errmsg" if echo "$errmsg" | grep -q "Permission denied\|No such file or directory\|Host key verification failed"; then derror "Could not create $DUMP_TARGET:$SAVE_PATH, you probably need to run \"kdumpctl propagate\"" return 1 fi if [[ $warn_once -eq 1 ]]; then dwarn "Network dump target is not usable, waiting for it to be ready..." warn_once=0 fi cur=$(date +%s) diff=$((cur - start_time)) # 60s time out if [[ $diff -gt 180 ]]; then break fi sleep 1 done dinfo "Could not create $DUMP_TARGET:$SAVE_PATH, ipaddr is not ready yet. You should check network connection" return 1 } check_ssh_target() { check_and_wait_network_ready } propagate_ssh_key() { if ! check_ssh_config; then derror "No ssh config specified in $KDUMP_CONFIG_FILE. Can't propagate" exit 1 fi local KEYFILE=$SSH_KEY_LOCATION local errmsg="Failed to propagate ssh key" #Check to see if we already created key, if not, create it. if [[ -f $KEYFILE ]]; then dinfo "Using existing keys..." else dinfo "Generating new ssh keys... " /usr/bin/ssh-keygen -t rsa -f "$KEYFILE" -N "" 2>&1 > /dev/null dinfo "done." fi #now find the target ssh user and server to contact. SSH_USER=$(echo "$DUMP_TARGET" | cut -d@ -f1) SSH_SERVER=$(echo "$DUMP_TARGET" | sed -e's/\(.*@\)\(.*$\)/\2/') #now send the found key to the found server ssh-copy-id -i "$KEYFILE" "$SSH_USER@$SSH_SERVER" RET=$? if [[ $RET == 0 ]]; then dinfo "$KEYFILE has been added to ~$SSH_USER/.ssh/authorized_keys on $SSH_SERVER" return 0 else derror "$errmsg, $KEYFILE failed in transfer to $SSH_SERVER" exit 1 fi } show_reserved_mem() { local mem local mem_mb mem=$(get_reserved_mem_size) mem_mb=$((mem / 1024 / 1024)) dinfo "Reserved ${mem_mb}MB memory for crash kernel" } save_raw() { local kdump_dir local raw_target raw_target=$(kdump_get_conf_val raw) [[ -z $raw_target ]] && return 0 [[ -b $raw_target ]] || { derror "raw partition $raw_target not found" return 1 } check_fs=$(lsblk --nodeps -npo FSTYPE "$raw_target") if [[ $(echo "$check_fs" | wc -w) -ne 0 ]]; then dwarn "Warning: Detected '$check_fs' signature on $raw_target, data loss is expected." return 0 fi kdump_dir=$(kdump_get_conf_val path) if [[ -z ${kdump_dir} ]]; then coredir="/var/crash/$(date +"%Y-%m-%d-%H:%M")" else coredir="${kdump_dir}/$(date +"%Y-%m-%d-%H:%M")" fi mkdir -p "$coredir" [[ -d $coredir ]] || { derror "failed to create $coredir" return 1 } if makedumpfile -R "$coredir/vmcore" < "$raw_target" > /dev/null 2>&1; then # dump found dinfo "Dump saved to $coredir/vmcore" # wipe makedumpfile header dd if=/dev/zero of="$raw_target" bs=1b count=1 2> /dev/null else rm -rf "$coredir" fi return 0 } local_fs_dump_target() { local _target if _target=$(grep -E "^ext[234]|^xfs|^btrfs|^minix" /etc/kdump.conf); then echo "$_target" | awk '{print $2}' fi } path_to_be_relabeled() { local _path _target _mnt="/" _rmnt if is_user_configured_dump_target; then if is_mount_in_dracut_args; then return fi _target=$(local_fs_dump_target) if [[ -n $_target ]]; then _mnt=$(get_mntpoint_from_target "$_target") if ! is_mounted "$_mnt"; then return fi else return fi fi _path=$(get_save_path) # if $_path is masked by other mount, we will not relabel it. _rmnt=$(df "$_mnt/$_path" 2> /dev/null | tail -1 | awk '{ print $NF }') if [[ $_rmnt == "$_mnt" ]]; then echo "$_mnt/$_path" fi } selinux_relabel() { local _path _i _attr _path=$(path_to_be_relabeled) if [[ -z $_path ]] || ! [[ -d $_path ]]; then return fi while IFS= read -r -d '' _i; do _attr=$(getfattr -m "security.selinux" "$_i" 2> /dev/null) if [[ -z $_attr ]]; then restorecon "$_i" fi done < <(find "$_path" -print0) } check_fence_kdump_config() { local hostname local ipaddrs local nodes hostname=$(hostname) ipaddrs=$(hostname -I) nodes=$(kdump_get_conf_val "fence_kdump_nodes") for node in $nodes; do if [[ $node == "$hostname" ]]; then derror "Option fence_kdump_nodes cannot contain $hostname" return 1 fi # node can be ipaddr if echo "$ipaddrs " | grep -q "$node "; then derror "Option fence_kdump_nodes cannot contain $node" return 1 fi done return 0 } check_dump_feasibility() { if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then return 0 fi check_kdump_feasibility } fadump_bootargs_append() { if [[ -f "$FADUMP_APPEND_ARGS_SYS_NODE" ]]; then output=$( { echo "${FADUMP_COMMANDLINE_APPEND}" > "$FADUMP_APPEND_ARGS_SYS_NODE" ; } 2>&1) if [ $? -eq 0 ]; then output=$(cat "$FADUMP_APPEND_ARGS_SYS_NODE") dinfo "fadump: additional parameters for capture kernel: '$output'" else dwarn "WARNING: failed to setup additional parameters for fadump capture kernel: '$output'" fi else dwarn "WARNING: this kernel does not support passing additional parameters to fadump capture kernel." fi } start_fadump() { fadump_bootargs_append echo 1 > "$FADUMP_REGISTER_SYS_NODE" if ! is_kernel_loaded "fadump"; then derror "fadump: failed to register" return 1 fi dinfo "fadump: registered successfully" return 0 } start_dump() { # On secure boot enabled Power systems, load kernel signing key on .ima for signature # verification using kexec file based syscall. if [[ "$(uname -m)" == ppc64le ]] && is_secure_boot_enforced; then load_kdump_kernel_key fi if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then start_fadump else load_kdump fi } check_failure_action_config() { local default_option local failure_action local option="failure_action" default_option=$(kdump_get_conf_val default) failure_action=$(kdump_get_conf_val failure_action) if [[ -z $failure_action ]] && [[ -z $default_option ]]; then return 0 elif [[ -n $failure_action ]] && [[ -n $default_option ]]; then derror "Cannot specify 'failure_action' and 'default' option together" return 1 fi if [[ -n $default_option ]]; then option="default" failure_action="$default_option" fi case "$failure_action" in reboot | halt | poweroff | shell | dump_to_rootfs) return 0 ;; *) dinfo $"Usage kdump.conf: $option {reboot|halt|poweroff|shell|dump_to_rootfs}" return 1 ;; esac } check_final_action_config() { local final_action final_action=$(kdump_get_conf_val final_action) if [[ -z $final_action ]]; then return 0 else case "$final_action" in reboot | halt | poweroff) return 0 ;; *) dinfo $"Usage kdump.conf: final_action {reboot|halt|poweroff}" return 1 ;; esac fi } start() { if ! check_dump_feasibility; then derror "Starting kdump: [FAILED]" return 1 fi if ! check_config; then derror "Starting kdump: [FAILED]" return 1 fi if sestatus 2> /dev/null | grep -q "SELinux status.*enabled"; then selinux_relabel fi if ! save_raw; then derror "Starting kdump: [FAILED]" return 1 fi if [[ $DEFAULT_DUMP_MODE == "kdump" ]] && is_kernel_loaded "kdump"; then dwarn "Kdump already running: [WARNING]" return 0 fi if check_ssh_config; then if ! check_ssh_target; then derror "Starting kdump: [FAILED]" return 1 fi fi if ! check_rebuild; then derror "Starting kdump: [FAILED]" return 1 fi if ! start_dump; then derror "Starting kdump: [FAILED]" return 1 fi dinfo "Starting kdump: [OK]" } reload() { if ! is_kernel_loaded "$DEFAULT_DUMP_MODE"; then dwarn "Kdump was not running: [WARNING]" fi if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then reload_fadump return else if ! stop_kdump; then derror "Stopping kdump: [FAILED]" return 1 fi fi dinfo "Stopping kdump: [OK]" if ! setup_initrd; then derror "Starting kdump: [FAILED]" return 1 fi if ! start_dump; then derror "Starting kdump: [FAILED]" return 1 fi dinfo "Starting kdump: [OK]" } stop_fadump() { echo 0 > "$FADUMP_REGISTER_SYS_NODE" if is_kernel_loaded "fadump"; then derror "fadump: failed to unregister" return 1 fi dinfo "fadump: unregistered successfully" return 0 } stop_kdump() { if is_secure_boot_enforced; then $KEXEC -s -p -u else $KEXEC -p -u fi # shellcheck disable=SC2181 if [[ $? != 0 ]]; then derror "kexec: failed to unload kdump kernel" return 1 fi dinfo "kexec: unloaded kdump kernel" return 0 } reload_fadump() { fadump_bootargs_append if echo 1 > "$FADUMP_REGISTER_SYS_NODE"; then dinfo "fadump: re-registered successfully" return 0 else # FADump could fail on older kernel where re-register # support is not enabled. Try stop/start from userspace # to handle such scenario. if stop_fadump; then start_fadump return fi fi return 1 } stop() { if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then stop_fadump else stop_kdump fi # shellcheck disable=SC2181 if [[ $? != 0 ]]; then derror "Stopping kdump: [FAILED]" return 1 fi dinfo "Stopping kdump: [OK]" return 0 } rebuild() { check_config || return 1 if check_ssh_config; then if ! check_ssh_target; then return 1 fi fi setup_initrd || return 1 dinfo "Rebuilding $TARGET_INITRD" rebuild_initrd } check_vmlinux() { # Use readelf to check if it's a valid ELF readelf -h "$1" &> /dev/null || return 1 } get_vmlinux_size() { local size=0 _msize while read -r _msize; do size=$((size + _msize)) done <<< "$(readelf -l -W "$1" | awk '/^ LOAD/{print $6}' 2> /dev/stderr)" echo $size } try_decompress() { # The obscure use of the "tr" filter is to work around older versions of # "grep" that report the byte offset of the line instead of the pattern. # Try to find the header ($1) and decompress from here for pos in $(tr "$1\n$2" "\n$2=" < "$4" | grep -abo "^$2"); do if ! type -P "$3" > /dev/null; then ddebug "Signiature detected but '$3' is missing, skip this decompressor" break fi pos=${pos%%:*} tail "-c+$pos" "$img" | $3 > "$5" 2> /dev/null if check_vmlinux "$5"; then ddebug "Kernel is extracted with '$3'" return 0 fi done return 1 } # Borrowed from linux/scripts/extract-vmlinux get_kernel_size() { # Prepare temp files: local tmp img=$1 tmp="$KDUMP_TMPDIR/vmlinux" # Try to check if it's a vmlinux already check_vmlinux "$img" && get_vmlinux_size "$img" && return 0 # That didn't work, so retry after decompression. try_decompress '\037\213\010' xy gunzip "$img" "$tmp" || try_decompress '\3757zXZ\000' abcde unxz "$img" "$tmp" || try_decompress 'BZh' xy bunzip2 "$img" "$tmp" || try_decompress '\135\0\0\0' xxx unlzma "$img" "$tmp" || try_decompress '\211\114\132' xy 'lzop -d' "$img" "$tmp" || try_decompress '\002!L\030' xxx 'lz4 -d' "$img" "$tmp" || try_decompress '(\265/\375' xxx unzstd "$img" "$tmp" # Finally check for uncompressed images or objects: [[ $? -eq 0 ]] && get_vmlinux_size "$tmp" && return 0 # Fallback to use iomem local _size=0 _seg while read -r _seg; do _size=$((_size + 0x${_seg#*-} - 0x${_seg%-*})) done <<< "$(grep -E "Kernel (code|rodata|data|bss)" /proc/iomem | cut -d ":" -f 1)" echo $_size } do_estimate() { local kdump_mods local -A large_mods local baseline local kernel_size mod_size initrd_size baseline_size runtime_size reserved_size estimated_size recommended_size _cryptsetup_overhead local size_mb=$((1024 * 1024)) setup_initrd if [[ ! -f $TARGET_INITRD ]]; then derror "kdumpctl estimate: kdump initramfs is not built yet." exit 1 fi kdump_mods="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/hostonly-kernel-modules.txt | tr '\n' ' ')" baseline=$(kdump_get_arch_recommend_size) if [[ ${baseline: -1} == "M" ]]; then baseline=${baseline%M} elif [[ ${baseline: -1} == "G" ]]; then baseline=$((${baseline%G} * 1024)) elif [[ ${baseline: -1} == "T" ]]; then baseline=$((${baseline%Y} * 1048576)) fi # The default pre-reserved crashkernel value baseline_size=$((baseline * size_mb)) # Current reserved crashkernel size reserved_size=$(get_reserved_mem_size) # A pre-estimated value for userspace usage and kernel # runtime allocation, 64M should good for most cases runtime_size=$((64 * size_mb)) # Kernel image size kernel_size=$(get_kernel_size "$KDUMP_KERNEL") # Kdump initramfs size initrd_size=$(du -b "$TARGET_INITRD" | awk '{print $1}') # Kernel modules static size after loaded mod_size=0 while read -r _name _size _; do if [[ " $kdump_mods " != *" $_name "* ]]; then continue fi mod_size=$((mod_size + _size)) # Mark module with static size larger than 2M as large module if [[ $((_size / size_mb)) -ge 1 ]]; then large_mods[$_name]=$_size fi done <<< "$(< /proc/modules)" # Extra memory usage required for LUKS2 decryption crypt_size=0 for _dev in $(get_all_kdump_crypt_dev); do _crypt_info=$(cryptsetup luksDump "/dev/block/$_dev") [[ $(echo "$_crypt_info" | sed -n "s/^Version:\s*\(.*\)/\1/p") == "2" ]] || continue for _mem in $(echo "$_crypt_info" | sed -n "s/\sMemory:\s*\(.*\)/\1/p" | sort -n -r); do crypt_size=$((crypt_size + _mem * 1024)) break done done if [[ $crypt_size -ne 0 ]]; then if [[ $(uname -m) == aarch64 ]]; then _cryptsetup_overhead=50 else _cryptsetup_overhead=20 fi crypt_size=$((crypt_size + _cryptsetup_overhead * size_mb)) echo -e "Encrypted kdump target requires extra memory, assuming using the keyslot with maximum memory requirement\n" fi estimated_size=$((kernel_size + mod_size + initrd_size + runtime_size + crypt_size)) if [[ $baseline_size -gt $estimated_size ]]; then recommended_size=$baseline_size else recommended_size=$estimated_size fi echo "Reserved crashkernel: $((reserved_size / size_mb))M" echo "Recommended crashkernel: $((recommended_size / size_mb))M" echo echo "Kernel image size: $((kernel_size / size_mb))M" echo "Kernel modules size: $((mod_size / size_mb))M" echo "Initramfs size: $((initrd_size / size_mb))M" echo "Runtime reservation: $((runtime_size / size_mb))M" [[ $crypt_size -ne 0 ]] && echo "LUKS required size: $((crypt_size / size_mb))M" echo -n "Large modules:" if [[ ${#large_mods[@]} -eq 0 ]]; then echo " <none>" else echo "" for _mod in "${!large_mods[@]}"; do echo " $_mod: ${large_mods[$_mod]}" done fi if [[ $reserved_size -lt $recommended_size ]]; then echo "WARNING: Current crashkernel size is lower than recommended size $((recommended_size / size_mb))M." fi } get_default_crashkernel() { local _dump_mode=$1 kdump_get_arch_recommend_crashkernel "$_dump_mode" } # Read kernel cmdline parameter for a specific kernel # $1: kernel path, DEFAULT or kernel path, ALL not accepted # $2: kernel cmldine parameter get_grub_kernel_boot_parameter() { local _kernel_path=$1 _para=$2 [[ $_kernel_path == ALL ]] && derror "kernel_path=ALL invalid for get_grub_kernel_boot_parameter" && return 1 grubby --info="$_kernel_path" | sed -En -e "/^args=.*$/{s/^.*(\s|\")${_para}=(\S*).*\"$/\2/p;q}" } # get dump mode by fadump value # return # - fadump, if fadump=on or fadump=nocma # - kdump, if fadump=off or empty fadump, return kdump # - error if otherwise get_dump_mode_by_fadump_val() { local _fadump_val=$1 if [[ -z $_fadump_val ]] || [[ $_fadump_val == off ]]; then echo -n kdump elif [[ $_fadump_val == on ]] || [[ $_fadump_val == nocma ]]; then echo -n fadump else derror "invalid fadump=$_fadump_val" return 1 fi } # get dump mode of a specific kernel # based on its fadump kernel cmdline parameter get_dump_mode_by_kernel() { local _kernel_path=$1 _fadump_val _dump_mode _fadump_val=$(get_grub_kernel_boot_parameter "$_kernel_path" fadump) if _dump_mode=$(get_dump_mode_by_fadump_val "$_fadump_val"); then echo -n "$_dump_mode" else derror "failed to get dump mode for kernel $_kernel_path" exit fi } _filter_grubby_kernel_str() { local _grubby_kernel_str=$1 echo -n "$_grubby_kernel_str" | sed -n -e 's/^kernel="\(.*\)"/\1/p' } _find_kernel_path_by_release() { local _release="$1" _grubby_kernel_str _kernel_path # Insert '/' before '+' to cope with grep's EREs _release=${_release//+/\\+} _grubby_kernel_str=$(grubby --info ALL | grep -E "^kernel=.*$_release(\/\w+)?\"$") _kernel_path=$(_filter_grubby_kernel_str "$_grubby_kernel_str") if [[ -z $_kernel_path ]]; then ddebug "kernel $_release doesn't exist" return 1 fi echo -n "$_kernel_path" } _get_current_running_kernel_path() { local _release _path _release=$(uname -r) if _path=$(_find_kernel_path_by_release "$_release"); then echo -n "$_path" else return 1 fi } _update_kernel_cmdline() { local _kernel_path=$1 _crashkernel=$2 _dump_mode=$3 _fadump_val=$4 if is_ostree; then if rpm-ostree kargs | grep -q "crashkernel="; then rpm-ostree kargs --replace="crashkernel=$_crashkernel" else rpm-ostree kargs --append="crashkernel=$_crashkernel" fi else grubby --args "crashkernel=$_crashkernel" --update-kernel "$_kernel_path" if [[ $_dump_mode == kdump ]]; then grubby --remove-args="fadump" --update-kernel "$_kernel_path" else grubby --args="fadump=$_fadump_val" --update-kernel "$_kernel_path" fi fi [[ -f /etc/zipl.conf ]] && zipl > /dev/null } _valid_grubby_kernel_path() { [[ -n "$1" ]] && grubby --info="$1" > /dev/null 2>&1 } # return all the kernel paths given a grubby kernel-path # # $1: kernel path accepted by grubby, e.g. DEFAULT, ALL, # /boot/vmlinuz-`uname -r` # return: kernel paths separated by space _get_all_kernels_from_grubby() { local _kernels _line _kernel_path _grubby_kernel_path=$1 for _line in $(grubby --info "$_grubby_kernel_path" | grep "^kernel="); do _kernel_path=$(_filter_grubby_kernel_str "$_line") _kernels="$_kernels $_kernel_path" done echo -n "$_kernels" } GRUB_ETC_DEFAULT="/etc/default/grub" # Update a kernel parameter in default grub conf # # If a value is specified, it will be inserted in the end. Otherwise it # would remove given kernel parameter. # # Note this function doesn't address the following cases, # 1. The kernel ignores everything on the command line after a '--'. So # simply adding the new entry to the end will fail if the cmdline # contains a --. # 2. If the value for a parameter contains spaces it can be quoted using # double quotes, for example param="value with spaces". This will # break the [^[:space:]\"] regex for the value. # 3. Dashes and underscores in the parameter name are equivalent. So # some_parameter and some-parameter are identical. # 4. Some parameters, e.g. efivar_ssdt, can be given multiple times. # 5. Some kernel parameters, e.g. quiet, doesn't have value # # $1: the name of the kernel command line parameter # $2: new value. If empty, given parameter would be removed _update_kernel_arg_in_grub_etc_default() { local _para=$1 _val=$2 _para_val if [[ $(uname -m) == s390x ]]; then return fi if [[ -n $_val ]]; then _para_val="$_para=$_val" fi # Update the command line /etc/default/grub, i.e. # on the line that starts with 'GRUB_CMDLINE_LINUX=', # 1) remove $para=$val if the it's the first arg # 2) remove all occurences of $para=$val # 3) insert $_para_val to end # 4) remove duplicate spaces left over by 1) or 2) or 3) # 5) remove space at the beginning of the string left over by 1) or 2) or 3) # 6) remove space at the end of the string left over by 1) or 2) or 3) sed -i -E "/^GRUB_CMDLINE_LINUX=/ { s/\"${_para}=[^[:space:]\"]*/\"/g; s/[[:space:]]+${_para}=[^[:space:]\"]*/ /g; s/\"$/ ${_para_val}\"/ s/[[:space:]]+/ /g; s/(\")[[:space:]]+/\1/g; s/[[:space:]]+(\")/\1/g; }" "$GRUB_ETC_DEFAULT" } # Read the kernel arg in default grub conf. # Note reading a kernel parameter that doesn't have a value isn't supported. # # $1: the name of the kernel command line parameter _read_kernel_arg_in_grub_etc_default() { sed -n -E "s/^GRUB_CMDLINE_LINUX=.*[[:space:]\"]${1}=([^[:space:]\"]*).*$/\1/p" "$GRUB_ETC_DEFAULT" } reset_crashkernel() { local _opt _val _dump_mode _fadump_val _reboot _grubby_kernel_path _kernel _kernels local _old_crashkernel _new_crashkernel _new_dump_mode _crashkernel_changed local _new_fadump_val _old_fadump_val _what_is_updated for _opt in "$@"; do case "$_opt" in --fadump=*) _val=${_opt#*=} if _dump_mode=$(get_dump_mode_by_fadump_val $_val); then _fadump_val=$_val else derror "failed to determine dump mode" exit fi ;; --kernel=*) _val=${_opt#*=} if ! _valid_grubby_kernel_path $_val; then derror "Invalid $_opt, please specify a valid kernel path, ALL or DEFAULT" exit fi _grubby_kernel_path=$_val ;; --reboot) _reboot=yes ;; *) derror "$_opt not recognized" exit 1 ;; esac done # 1. OSTree systems use "rpm-ostree kargs" instead of grubby to manage kernel command # line. --kernel=ALL doesn't make sense for OStree. # 2. We don't have any OSTree POWER systems so the dump mode is always kdump. # 3. "rpm-ostree kargs" would prompt the user to reboot the system after # modifying the kernel command line so there is no need for kexec-tools # to repeat it. if is_ostree; then _old_crashkernel=$(rpm-ostree kargs | sed -n -E 's/.*(^|\s)crashkernel=(\S*).*/\2/p') _new_dump_mode=kdump _new_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_new_dump_mode") if [[ $_old_crashkernel != "$_new_crashkernel" ]]; then _update_kernel_cmdline "" "$_new_crashkernel" "$_new_dump_mode" "" if [[ $_reboot == yes ]]; then systemctl reboot fi fi return fi # For non-ppc64le systems, the dump mode is always kdump since only ppc64le # has FADump. if [[ -z $_dump_mode && $(uname -m) != ppc64le ]]; then _dump_mode=kdump _fadump_val=off fi # If the dump mode is determined, we can also know the default crashkernel value if [[ -n $_dump_mode ]]; then _crashkernel=$(kdump_get_arch_recommend_crashkernel "$_dump_mode") fi # If --kernel-path=ALL, update GRUB_CMDLINE_LINUX in /etc/default/grub. # # An exception case is when the ppc64le user doesn't specify the fadump value. # In this case, the dump mode would be determined by parsing the kernel # command line of the kernel(s) to be updated thus don't update GRUB_CMDLINE_LINUX. # # The following code has been simplified because of what has been done early, # - set the dump mode as kdump for non-ppc64le cases # - retrieved the default crashkernel value for given dump mode if [[ $_grubby_kernel_path == ALL && -n $_dump_mode ]]; then _update_kernel_arg_in_grub_etc_default crashkernel "$_crashkernel" # remove the fadump if fadump is disabled if [[ $_fadump_val == off ]]; then _fadump_val="" fi _update_kernel_arg_in_grub_etc_default fadump "$_fadump_val" fi # If kernel-path not specified, either # - use KDUMP_KERNELVER if it's defined # - use current running kernel if [[ -z $_grubby_kernel_path ]]; then if [[ -z $KDUMP_KERNELVER ]] || ! _kernel_path=$(_find_kernel_path_by_release "$KDUMP_KERNELVER"); then if ! _kernel_path=$(_get_current_running_kernel_path); then derror "no running kernel found" exit 1 fi fi _kernels=$_kernel_path else _kernels=$(_get_all_kernels_from_grubby "$_grubby_kernel_path") fi for _kernel in $_kernels; do if [[ -z $_dump_mode ]]; then _new_dump_mode=$(get_dump_mode_by_kernel "$_kernel") _new_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_new_dump_mode") _new_fadump_val=$(get_grub_kernel_boot_parameter "$_kernel" fadump) else _new_dump_mode=$_dump_mode _new_crashkernel=$_crashkernel _new_fadump_val=$_fadump_val fi _old_crashkernel=$(get_grub_kernel_boot_parameter "$_kernel" crashkernel) _old_fadump_val=$(get_grub_kernel_boot_parameter "$_kernel" fadump) [[ "$_new_fadump_val" == off ]] && _new_fadump_val="" if [[ $_old_crashkernel != "$_new_crashkernel" || $_old_fadump_val != "$_new_fadump_val" ]]; then _update_kernel_cmdline "$_kernel" "$_new_crashkernel" "$_new_dump_mode" "$_new_fadump_val" if [[ $_reboot != yes ]]; then if [[ $_old_crashkernel != "$_new_crashkernel" ]]; then _what_is_updated="Updated crashkernel=$_new_crashkernel" else # This case happens only when switching between fadump=on and fadump=nocma _what_is_updated="Updated fadump=$_new_fadump_val" fi dwarn "$_what_is_updated for kernel=$_kernel. Please reboot the system for the change to take effect." fi _crashkernel_changed=yes fi done if [[ $_reboot == yes && $_crashkernel_changed == yes ]]; then reboot fi } _is_bootloader_installed() { if [[ $(uname -m) == s390x ]]; then test -f /etc/zipl.conf else test -f /boot/grub2/grub.cfg fi } _update_crashkernel() { local _kernel _kver _dump_mode _old_default_crashkernel _new_default_crashkernel _fadump_val _msg _kernel=$1 _dump_mode=$(get_dump_mode_by_kernel "$_kernel") _old_default_crashkernel=$(get_grub_kernel_boot_parameter "$_kernel" crashkernel) _kver=$(parse_kver_from_path "$_kernel") # The second argument is for the case of aarch64, where installing a 64k variant on a 4k kernel, or vice versa _new_default_crashkernel=$(kdump_get_arch_recommend_crashkernel "$_dump_mode" "$_kver") if [[ $_old_default_crashkernel != "$_new_default_crashkernel" ]]; then _fadump_val=$(get_grub_kernel_boot_parameter "$_kernel" fadump) if _update_kernel_cmdline "$_kernel" "$_new_default_crashkernel" "$_dump_mode" "$_fadump_val"; then _msg="For kernel=$_kernel, crashkernel=$_new_default_crashkernel now. Please reboot the system for the change to take effet." _msg+=" Note if you don't want kexec-tools to manage the crashkernel kernel parameter, please set auto_reset_crashkernel=no in /etc/kdump.conf." dinfo "$_msg" fi fi } # shellcheck disable=SC2154 # false positive when dereferencing an array reset_crashkernel_after_update() { local _kernel if ! _is_bootloader_installed; then return fi for _kernel in $(_get_all_kernels_from_grubby ALL); do _update_crashkernel "$_kernel" done } # read the value of an environ variable from given environ file path # # The environment variable entries in /proc/[pid]/environ are separated # by null bytes instead of by spaces. # # $1: environment variable # $2: environ file path read_proc_environ_var() { local _var=$1 _environ_path=$2 sed -n -E "s/.*(^|\x00)${_var}=([^\x00]*).*/\2/p" < "$_environ_path" } _OSBUILD_ENVIRON_PATH='/proc/1/environ' _is_osbuild() { [[ $(read_proc_environ_var container "$_OSBUILD_ENVIRON_PATH") == bwrap-osbuild ]] } reset_crashkernel_for_installed_kernel() { local _installed_kernel # During package install, only try to reset crashkernel for osbuild # thus to avoid calling grubby when installing os via anaconda if ! _is_bootloader_installed && ! _is_osbuild; then return fi if ! _installed_kernel=$(_find_kernel_path_by_release "$1"); then exit 1 fi if _is_osbuild; then if ! grep -qs crashkernel= /etc/kernel/cmdline; then reset_crashkernel "--kernel=$_installed_kernel" fi return fi _update_crashkernel "$_installed_kernel" } if [[ ! -f $KDUMP_CONFIG_FILE ]]; then derror "Error: No kdump config file found!" exit 1 fi set_kdump_test_id() { local _id=$1 KDUMP_COMMANDLINE_APPEND+=" $_id " if ! reload >& /dev/null; then derror "Set kdump test id fail." exit 1 fi } # $1: success/fail/pending/manual/clear # $2: test id set_vmcore_creation_status() { local _status=$1 local _kdump_test_id _dir=$(dirname "$VMCORE_CREATION_STATUS") [[ -d "$_dir" ]] || mkdir -p "$_dir" [[ -w "$_dir" ]] || chmod +w "$_dir" case "$_status" in pending) _kdump_test_id="kdump_test_id=$(date +%s-%N)" set_kdump_test_id "$_kdump_test_id" echo "$_status $_kdump_test_id" > "$VMCORE_CREATION_STATUS" ;; success | fail | manual) sed -E -i "s/^\w+/$_status/" "$VMCORE_CREATION_STATUS" ;; clear) rm -f "$VMCORE_CREATION_STATUS" ;; *) return esac sync -f "$_dir" } fetch_status() { local _test_id="$1" _mnt local _status _target is_raw_dump_target && return 2 _status="$(get_save_path)/kdump-test-$_test_id/vmcore-creation.status" if is_nfs_dump_target || is_fs_dump_target; then if is_fs_dump_target; then _target=$(fs_dump_target) else _target=$(kdump_get_conf_val nfs) fi _mnt=$(get_mntpoint_from_target "$_target") if [[ -z "$_mnt" ]] || ! is_mounted "$_mnt"; then mkdir -p "$TMPMNT" mount "$_target" "$TMPMNT" -o defaults || \ { dwarn "Failed to mount $_target" && return 2; } _mnt="$TMPMNT" fi _status="$_mnt/$_status" elif is_ssh_dump_target; then local _scp_address if is_ipv6_address "${OPT[_target]}"; then _scp_address="${OPT[_target]%@*}@[${OPT[_target]#*@}]" else _scp_address="${OPT[_target]}" fi scp -q -i "${OPT[sshkey]}" -o BatchMode=yes \ "$_scp_address:$_status" \ "$KDUMP_TMPDIR" case "$?" in 0) # success ;; 1) # file not found return 1 ;; 255) # no connection to host return 2 esac _status="$KDUMP_TMPDIR/vmcore-creation.status" fi [[ -f "$_status" ]] || return 1 grep -q "success" "$_status" && return 0 || return 1 } check_vmcore_creation_status() { local _status _test_id _timestamp _status_date [[ ${VMCORE_CREATION_NOTIFICATION,,} == "yes" ]] || return [[ "$DEFAULT_DUMP_MODE" == "kdump" ]] || return if [[ ! -s "$VMCORE_CREATION_STATUS" ]]; then dwarn "Notice: No vmcore creation test performed!" return fi read -r _status _test_id < "$VMCORE_CREATION_STATUS" _test_id=${_test_id#*=} _timestamp=${_test_id%-*} _status_date=$(date -d "@$_timestamp") if [[ "$_status" == "pending" ]]; then fetch_status "$_test_id" case "$?" in 0) _status="success" ;; 1) _status="fail" ;; *) _status="manual" ;; esac set_vmcore_creation_status "$_status" fi case "$_status" in success) dinfo "Notice: Last successful vmcore creation on $_status_date" ;; fail) dwarn "Notice: Last NOT successful vmcore creation on $_status_date" ;; manual) dwarn "Notice: Require manual check for kdump test of $_status_date" ;; *) derror "Unknown test status: $_status" ;; esac } kdump_test() { if ! is_kernel_loaded "$DEFAULT_DUMP_MODE"; then derror "Kdump needs be operational before test." exit 1 fi if [[ ! "$DEFAULT_DUMP_MODE" == "kdump" ]]; then derror "Only kdump is supported for test." exit 1 fi if [[ ! "$1" == "--force" ]]; then read -r -p "DANGER!!! Will perform a kdump test by crashing the system, proceed? (y/N): " input case $input in [Yy] ) dinfo "Start kdump test..." ;; * ) dinfo "Operation cancelled." exit 0 ;; esac fi set_vmcore_creation_status 'pending' echo c > /proc/sysrq-trigger } main() { # Determine if the dump mode is kdump or fadump determine_dump_mode case "$1" in start) if [[ -s /proc/vmcore ]]; then save_core reboot else start fi ;; stop) stop ;; status) EXIT_CODE=0 is_kernel_loaded "$DEFAULT_DUMP_MODE" case "$?" in 0) dinfo "Kdump is operational" EXIT_CODE=0 ;; 1) dinfo "Kdump is not operational" EXIT_CODE=3 ;; esac check_vmcore_creation_status exit $EXIT_CODE ;; reload) reload ;; restart) stop start ;; rebuild) rebuild ;; condrestart) ;; propagate) propagate_ssh_key ;; showmem) show_reserved_mem ;; estimate) do_estimate ;; get-default-crashkernel) get_default_crashkernel "$2" ;; reset-crashkernel) shift reset_crashkernel "$@" ;; test) shift kdump_test "$@" ;; _reset-crashkernel-after-update) if [[ $(kdump_get_conf_val auto_reset_crashkernel) != no ]]; then reset_crashkernel_after_update fi ;; _reset-crashkernel-for-installed_kernel) if [[ $(kdump_get_conf_val auto_reset_crashkernel) != no ]]; then reset_crashkernel_for_installed_kernel "$2" fi ;; *) dinfo $"Usage: $0 {estimate|start|stop|status|restart|reload|rebuild|reset-crashkernel|propagate|showmem|test}" exit 1 ;; esac } # Other kdumpctl instances will block in queue, until this one exits single_instance_lock # To avoid fd 9 leaking, we invoke a subshell, close fd 9 and call main. # So that fd isn't leaking when main is invoking a subshell. ( exec 9<&- main "$@" )
[+]
..
[-] pip3.9
[edit]
[-] newgidmap
[edit]
[-] forever
[edit]
[-] sg_zone
[edit]
[-] gml2gv
[edit]
[-] stream
[edit]
[-] which
[edit]
[-] gpgparsemail
[edit]
[-] delv
[edit]
[-] mdb_copy
[edit]
[-] doveadm
[edit]
[-] msgcmp
[edit]
[-] rview
[edit]
[-] mailx.s-nail
[edit]
[-] mysqlimport
[edit]
[-] krb5-config
[edit]
[-] rpmdb
[edit]
[-] wc
[edit]
[-] find-repos-of-install
[edit]
[-] hb-ot-shape-closure
[edit]
[-] gcc-ranlib
[edit]
[-] gpg-error-config
[edit]
[-] cmsutil
[edit]
[-] myisampack
[edit]
[-] dpkg-split
[edit]
[-] powernow-k8-decode
[edit]
[-] semodule_expand
[edit]
[-] sieve-test
[edit]
[-] ea-php81-pecl
[edit]
[-] msgmerge
[edit]
[-] ping
[edit]
[-] gdbus-codegen
[edit]
[-] tload
[edit]
[-] ldd
[edit]
[-] nl-class-add
[edit]
[-] dumpkeys
[edit]
[-] whoami
[edit]
[-] nl-class-list
[edit]
[-] galera_new_cluster
[edit]
[-] msgunfmt
[edit]
[-] wmf2svg
[edit]
[-] systemd-inhibit
[edit]
[-] autoheader
[edit]
[-] seq
[edit]
[-] sg_raw
[edit]
[-] ul
[edit]
[-] captoinfo
[edit]
[-] lsipc
[edit]
[-] tail
[edit]
[-] btattach
[edit]
[-] gneqn
[edit]
[-] nmtui-hostname
[edit]
[-] lastcomm
[edit]
[-] blkrawverify
[edit]
[-] command
[edit]
[-] sccmap
[edit]
[-] yes
[edit]
[-] dnf-3
[edit]
[-] sg_compare_and_write
[edit]
[-] neato
[edit]
[-] mysql_upgrade
[edit]
[-] sg_logs
[edit]
[-] sg_unmap
[edit]
[-] pkexec
[edit]
[-] grub2-mkpasswd-pbkdf2
[edit]
[-] mysql_plugin
[edit]
[-] pkttyagent
[edit]
[-] pkla-admin-identities
[edit]
[-] imunify-antivirus
[edit]
[-] login
[edit]
[-] aria_read_log
[edit]
[-] lsiio
[edit]
[-] pic
[edit]
[-] vlock
[edit]
[-] gslj
[edit]
[-] modulemd-validator
[edit]
[-] mandb
[edit]
[-] teamdctl
[edit]
[-] fg
[edit]
[-] mariadb-fix-extensions
[edit]
[-] defncopy
[edit]
[-] clear
[edit]
[-] sg
[edit]
[-] tac
[edit]
[-] dotty
[edit]
[-] gpio-watch
[edit]
[-] rpcinfo
[edit]
[-] update-crypto-policies
[edit]
[-] utmpdump
[edit]
[-] grub2-fstest
[edit]
[-] msgcomm
[edit]
[-] btmon
[edit]
[-] dnsdomainname
[edit]
[-] wireplumber
[edit]
[-] systemd-run
[edit]
[-] nl-neightbl-list
[edit]
[-] pydoc
[edit]
[-] zforce
[edit]
[-] sg_start
[edit]
[-] whiptail
[edit]
[-] expr
[edit]
[-] pipewire-aes67
[edit]
[-] bond2team
[edit]
[-] unxz
[edit]
[-] sg_seek
[edit]
[-] osinfo-detect
[edit]
[-] sg_persist
[edit]
[-] readlink
[edit]
[-] Mail
[edit]
[-] pipewire-pulse
[edit]
[-] printenv
[edit]
[-] mysql_secure_installation
[edit]
[-] lto-dump
[edit]
[-] grub2-mklayout
[edit]
[-] ssh-copy-id
[edit]
[-] hb-subset
[edit]
[-] links
[edit]
[-] gtk-update-icon-cache
[edit]
[-] mountpoint
[edit]
[-] sg_sat_set_features
[edit]
[-] xdg-dbus-proxy
[edit]
[-] grep
[edit]
[-] package-cleanup
[edit]
[-] hb-view
[edit]
[-] cmp
[edit]
[-] sg_safte
[edit]
[-] nl-link-list
[edit]
[-] ipcrm
[edit]
[-] ausyscall
[edit]
[-] resolveip
[edit]
[-] named-rrchecker
[edit]
[-] cpan
[edit]
[-] runcon
[edit]
[-] fprintd-delete
[edit]
[-] nl-route-list
[edit]
[-] dir
[edit]
[-] nisdomainname
[edit]
[-] gxl2dot
[edit]
[-] edgepaint
[edit]
[-] systemd-cat
[edit]
[-] rmdir
[edit]
[-] ps2pdf12
[edit]
[-] libtoolize
[edit]
[-] mysql_fix_extensions
[edit]
[-] nl-addr-add
[edit]
[-] mpstat
[edit]
[-] sg_read_attr
[edit]
[-] ptar
[edit]
[-] update-ca-trust
[edit]
[-] fc-cat
[edit]
[-] keyctl
[edit]
[-] nice
[edit]
[-] sqlite3
[edit]
[-] sg_sat_identify
[edit]
[-] chcat
[edit]
[-] sg_reassign
[edit]
[-] wsrep_sst_mariabackup
[edit]
[-] scp
[edit]
[-] lastlog
[edit]
[-] systemd-stdio-bridge
[edit]
[-] getkeycodes
[edit]
[-] osinfo-query
[edit]
[-] aria_dump_log
[edit]
[-] c++
[edit]
[-] nf-exp-add
[edit]
[-] xdg-email
[edit]
[-] aria_ftdump
[edit]
[-] signver
[edit]
[-] fc-cache
[edit]
[-] doveconf
[edit]
[-] ca-legacy
[edit]
[-] uapi
[edit]
[-] dpkg-divert
[edit]
[-] dwp
[edit]
[-] repotrack
[edit]
[-] page_owner_sort
[edit]
[-] echo
[edit]
[-] flatpak
[edit]
[-] git-upload-pack
[edit]
[-] slencheck
[edit]
[-] yumdownloader
[edit]
[-] pm2-docker
[edit]
[-] systemd-machine-id-setup
[edit]
[-] innochecksum
[edit]
[-] lsgpio
[edit]
[-] sha1sum
[edit]
[-] eject
[edit]
[-] grub2-mkimage
[edit]
[-] gsettings
[edit]
[-] myisamchk
[edit]
[-] imunify-agent-proxy
[edit]
[-] slabinfo
[edit]
[-] pk12util
[edit]
[-] setup-nsssysinit.sh
[edit]
[-] gpasswd
[edit]
[-] sgp_dd
[edit]
[-] simc_lsmplugin
[edit]
[-] pftp
[edit]
[-] msggrep
[edit]
[-] col
[edit]
[-] ea-php81-pear
[edit]
[-] composite
[edit]
[-] unshare
[edit]
[-] zcat
[edit]
[-] tic
[edit]
[-] php
[edit]
[-] gio-querymodules-64
[edit]
[-] trust
[edit]
[-] mkfontdir
[edit]
[-] nl-classid-lookup
[edit]
[-] identify
[edit]
[-] nss-policy-check
[edit]
[-] lsmem
[edit]
[-] html2text
[edit]
[-] rpmverify
[edit]
[-] unix2mac
[edit]
[-] wmf2fig
[edit]
[-] zipdetails
[edit]
[-] tapestat
[edit]
[-] reposync
[edit]
[-] perl5.32.1
[edit]
[-] piconv
[edit]
[-] gdk-pixbuf-query-loaders-64
[edit]
[-] scl
[edit]
[-] mpris-proxy
[edit]
[-] getfattr
[edit]
[-] bc
[edit]
[-] nf-queue
[edit]
[-] hostid
[edit]
[-] sg_read_buffer
[edit]
[-] write
[edit]
[-] zipnote
[edit]
[-] msgfilter
[edit]
[-] dbus-uuidgen
[edit]
[-] msguniq
[edit]
[-] xdg-icon-resource
[edit]
[-] sg_sat_read_gplog
[edit]
[-] linux32
[edit]
[-] gvpack
[edit]
[-] nmtui-connect
[edit]
[-] rpmquery
[edit]
[-] nl
[edit]
[-] gpg-card
[edit]
[-] psfgettable
[edit]
[-] fc-pattern
[edit]
[-] cal
[edit]
[-] blkparse
[edit]
[-] wsrep_sst_rsync
[edit]
[-] dijkstra
[edit]
[-] batch
[edit]
[-] arch
[edit]
[-] cpapi2
[edit]
[-] nl-class-delete
[edit]
[-] perlbug
[edit]
[-] view
[edit]
[-] cyrusbdb2current
[edit]
[-] gnroff
[edit]
[-] symlinks
[edit]
[-] systemd-detect-virt
[edit]
[-] zipcloak
[edit]
[-] mariadb-import
[edit]
[-] false
[edit]
[-] npx
[edit]
[-] sadf
[edit]
[-] aspell
[edit]
[-] vdoforcerebuild
[edit]
[-] systemd-id128
[edit]
[-] perlthanks
[edit]
[-] hostname
[edit]
[-] setfacl
[edit]
[-] chardetect
[edit]
[-] audit2allow
[edit]
[-] linux64
[edit]
[-] gettext.sh
[edit]
[-] journalctl
[edit]
[-] aria_chk
[edit]
[-] setsid
[edit]
[-] mysqlslap
[edit]
[-] quota
[edit]
[-] dtrace
[edit]
[-] ld.bfd
[edit]
[-] update-desktop-database
[edit]
[-] nf-ct-list
[edit]
[-] cxpm
[edit]
[-] usleep
[edit]
[-] ranlib
[edit]
[-] showkey
[edit]
[-] pydoc3
[edit]
[-] xdg-desktop-icon
[edit]
[-] recode-sr-latin
[edit]
[-] im360-k8s-syncer
[edit]
[-] spell
[edit]
[-] sftp
[edit]
[-] setkeycodes
[edit]
[-] gtk-launch
[edit]
[-] sg_timestamp
[edit]
[-] red
[edit]
[-] sg_ses_microcode
[edit]
[-] renew-dummy-cert
[edit]
[-] xgettext
[edit]
[-] bashbug-64
[edit]
[-] mariadb-tzinfo-to-sql
[edit]
[-] sha224sum
[edit]
[-] mount
[edit]
[-] pip-3.9
[edit]
[-] mac2unix
[edit]
[-] pcre-config
[edit]
[-] mariadb-plugin
[edit]
[-] nail
[edit]
[-] brotli
[edit]
[-] ea-php81
[edit]
[-] xzgrep
[edit]
[-] objdump
[edit]
[-] gv2gxl
[edit]
[-] nl-cls-list
[edit]
[-] pinfo
[edit]
[-] hunspell
[edit]
[-] sleep
[edit]
[-] zip
[edit]
[-] yum-debug-restore
[edit]
[-] jq
[edit]
[-] protoc-gen-c
[edit]
[-] gdbm_dump
[edit]
[-] chown
[edit]
[-] osinfo-db-validate
[edit]
[-] ima-setup
[edit]
[-] ptx
[edit]
[-] fc-match
[edit]
[-] soelim
[edit]
[-] repo-graph
[edit]
[-] size
[edit]
[-] scriptlive
[edit]
[-] nl-neigh-list
[edit]
[-] df
[edit]
[-] gcov
[edit]
[-] kernel-install
[edit]
[-] pango-list
[edit]
[-] sg_dd
[edit]
[-] setmetamode
[edit]
[-] envml
[edit]
[-] id
[edit]
[-] icu-config
[edit]
[-] ar
[edit]
[-] pl2pm
[edit]
[-] kbdinfo
[edit]
[-] lsblk
[edit]
[-] soelim.groff
[edit]
[-] notify-send
[edit]
[-] aclocal
[edit]
[-] sha256sum
[edit]
[-] mmdblookup
[edit]
[-] preconv
[edit]
[-] conjure
[edit]
[-] xzfgrep
[edit]
[-] systemd-firstboot
[edit]
[-] pngfix
[edit]
[-] p11-kit
[edit]
[-] mariadb-dump
[edit]
[-] yum-config-manager
[edit]
[-] garbd
[edit]
[-] aserver
[edit]
[-] odbc_config
[edit]
[-] python3
[edit]
[-] bg
[edit]
[-] catchsegv
[edit]
[-] elinks
[edit]
[-] zmore
[edit]
[-] xslt-config
[edit]
[-] type
[edit]
[-] lchfn
[edit]
[-] x86_64-redhat-linux-gcc
[edit]
[-] lwp-dump
[edit]
[-] uname
[edit]
[-] wall
[edit]
[-] sg_sync
[edit]
[-] bunzip2
[edit]
[-] lsscsi
[edit]
[-] factor
[edit]
[-] pango-view
[edit]
[-] strace-log-merge
[edit]
[-] pre-grohtml
[edit]
[-] glib-genmarshal
[edit]
[-] ghostscript
[edit]
[-] run-parts
[edit]
[-] bash
[edit]
[-] hostnamectl
[edit]
[-] isosize
[edit]
[-] tdspool
[edit]
[-] pphs
[edit]
[-] nl-qdisc-add
[edit]
[-] gdbus
[edit]
[-] appstream-util
[edit]
[-] kdumpctl
[edit]
[-] bwrap
[edit]
[-] busctl
[edit]
[-] rev
[edit]
[-] namei
[edit]
[-] btrecord
[edit]
[-] md5sum
[edit]
[-] dbus-monitor
[edit]
[-] sha224hmac
[edit]
[-] nmtui-edit
[edit]
[-] lexgrog
[edit]
[-] gdbm_load
[edit]
[-] verify_blkparse
[edit]
[-] yum
[edit]
[-] gvmap.sh
[edit]
[-] certutil
[edit]
[-] iusql
[edit]
[-] bluetoothctl
[edit]
[-] sg_get_config
[edit]
[-] mariadb-hotcopy
[edit]
[-] mariadb-waitpid
[edit]
[-] strip
[edit]
[-] systemd-umount
[edit]
[-] usb-devices
[edit]
[-] gs
[edit]
[-] resizecons
[edit]
[-] nl-route-delete
[edit]
[-] gpgsplit
[edit]
[-] python3-config
[edit]
[-] centrino-decode
[edit]
[-] mysql_find_rows
[edit]
[-] pure-pwconvert
[edit]
[-] mysql_embedded
[edit]
[-] sg_write_x
[edit]
[-] ptargrep
[edit]
[-] wget
[edit]
[-] tmpwatch
[edit]
[-] json_reformat
[edit]
[-] bzfgrep
[edit]
[-] mogrify
[edit]
[-] animate
[edit]
[-] unix2dos
[edit]
[-] rvi
[edit]
[-] w
[edit]
[-] nl-link-name2ifindex
[edit]
[-] getconf
[edit]
[-] gr2fonttest
[edit]
[-] truncate
[edit]
[-] repomanage
[edit]
[-] column
[edit]
[-] authselect
[edit]
[-] bzdiff
[edit]
[-] fuse2fs
[edit]
[-] nl-addr-list
[edit]
[-] nm
[edit]
[-] gencat
[edit]
[-] split
[edit]
[-] funzip
[edit]
[-] scriptreplay
[edit]
[-] gzip
[edit]
[-] msgfmt.py
[edit]
[-] gpgrt-config
[edit]
[-] mytop
[edit]
[-] ndptool
[edit]
[-] nl-nh-list
[edit]
[-] sg_bg_ctl
[edit]
[-] vdodumpconfig
[edit]
[-] psfstriptable
[edit]
[-] pm2-runtime
[edit]
[-] glib-mkenums
[edit]
[-] sg_test_rwbuf
[edit]
[-] unflatten
[edit]
[-] canberra-boot
[edit]
[-] checkpolicy
[edit]
[-] blkiomon
[edit]
[-] unzip
[edit]
[-] udevadm
[edit]
[-] sestatus
[edit]
[-] zone2sql
[edit]
[-] mdb_dump
[edit]
[-] clockdiff
[edit]
[-] import
[edit]
[-] linux-boot-prober
[edit]
[-] choom
[edit]
[-] sh
[edit]
[-] g++
[edit]
[-] ea-php84
[edit]
[-] plymouth
[edit]
[-] yat2m
[edit]
[-] info
[edit]
[-] sgm_dd
[edit]
[-] toe
[edit]
[-] zdump
[edit]
[-] appstream-compose
[edit]
[-] mariadb-find-rows
[edit]
[-] intel-speed-select
[edit]
[-] sievec
[edit]
[-] modutil
[edit]
[-] pm2
[edit]
[-] montage
[edit]
[-] dpkg-deb
[edit]
[-] libwmf-fontmap
[edit]
[-] sg_write_long
[edit]
[-] zdiff
[edit]
[-] vimtutor
[edit]
[-] grub2-syslinux2cfg
[edit]
[-] tmon
[edit]
[-] sg_write_buffer
[edit]
[-] dbus-update-activation-environment
[edit]
[-] python-config
[edit]
[-] pr
[edit]
[-] xsltproc
[edit]
[-] pkgconf
[edit]
[-] mysqlhotcopy
[edit]
[-] ps2pdf
[edit]
[-] update-mime-database
[edit]
[-] mariadb-binlog
[edit]
[-] acyclic
[edit]
[-] lwp-download
[edit]
[-] mysql_install_db
[edit]
[-] checkmodule
[edit]
[-] msginit
[edit]
[-] gslp
[edit]
[-] find
[edit]
[-] fincore
[edit]
[-] dirmngr
[edit]
[-] sha384hmac
[edit]
[-] file
[edit]
[-] automake-1.16
[edit]
[-] python3.9
[edit]
[-] pflags
[edit]
[-] grub2-mkrescue
[edit]
[-] blktrace
[edit]
[-] zfgrep
[edit]
[-] ea-php84-pecl
[edit]
[-] dbiprof
[edit]
[-] rnano
[edit]
[-] logname
[edit]
[-] mcookie
[edit]
[-] fips-mode-setup
[edit]
[-] mysql_convert_table_format
[edit]
[-] gcov-dump
[edit]
[-] libpng16-config
[edit]
[-] autoconf
[edit]
[-] ps2pdf14
[edit]
[-] bzgrep
[edit]
[-] flock
[edit]
[-] printafm
[edit]
[-] autoupdate
[edit]
[-] pm2-dev
[edit]
[-] cifsiostat
[edit]
[-] tee
[edit]
[-] python-html2text
[edit]
[-] wsrep_sst_mysqldump
[edit]
[-] sync
[edit]
[-] myisamlog
[edit]
[-] cksum
[edit]
[-] sudoreplay
[edit]
[-] rsvg-convert
[edit]
[-] gawk
[edit]
[-] systemd-repart
[edit]
[-] bzcat
[edit]
[-] unalias
[edit]
[-] users
[edit]
[-] systemd-tmpfiles
[edit]
[-] gcc-ar
[edit]
[-] nmcli
[edit]
[-] shuf
[edit]
[-] lastb
[edit]
[-] myisam_ftdump
[edit]
[-] sotruss
[edit]
[-] cpupower
[edit]
[-] aria_pack
[edit]
[-] encguess
[edit]
[-] pdf2ps
[edit]
[-] slabtop
[edit]
[-] libnetcfg
[edit]
[-] ld.gold
[edit]
[-] colcrt
[edit]
[-] xzcat
[edit]
[-] xzegrep
[edit]
[-] gpgv
[edit]
[-] man-recode
[edit]
[-] chfn
[edit]
[-] gcc
[edit]
[-] lesspipe.sh
[edit]
[-] lsphp
[edit]
[-] pf2afm
[edit]
[-] autom4te
[edit]
[-] freebcp
[edit]
[-] sg_map
[edit]
[-] grub2-glue-efi
[edit]
[-] traceroute
[edit]
[-] ps2pdf13
[edit]
[-] gtester
[edit]
[-] perl
[edit]
[-] prezip
[edit]
[-] cpansign
[edit]
[-] crc32
[edit]
[-] autoscan
[edit]
[-] pod2html
[edit]
[-] lslocks
[edit]
[-] grub2-render-label
[edit]
[-] free
[edit]
[-] unlink
[edit]
[-] msgconv
[edit]
[-] systemd-ask-password
[edit]
[-] sg_rdac
[edit]
[-] c89
[edit]
[-] podchecker
[edit]
[-] h2ph
[edit]
[-] catman
[edit]
[-] debuginfod-find
[edit]
[-] cc
[edit]
[-] mkfontscale
[edit]
[-] sss_ssh_knownhostsproxy
[edit]
[-] sprof
[edit]
[-] grub2-mknetdir
[edit]
[-] enc2xs
[edit]
[-] zone2json
[edit]
[-] unzipsfx
[edit]
[-] od
[edit]
[-] protoc
[edit]
[-] circo
[edit]
[-] dpkg-statoverride
[edit]
[-] ncat
[edit]
[-] freetype-config
[edit]
[-] mdb_load
[edit]
[-] nm-online
[edit]
[-] locate
[edit]
[-] hb-shape
[edit]
[-] make
[edit]
[-] cpan-mirrors
[edit]
[-] systemd-mount
[edit]
[-] flex++
[edit]
[-] mariadb
[edit]
[-] nano
[edit]
[-] osage
[edit]
[-] pathchk
[edit]
[-] install
[edit]
[-] look
[edit]
[-] grub2-script-check
[edit]
[-] systemctl
[edit]
[-] nf-exp-delete
[edit]
[-] systemd-dissect
[edit]
[-] time
[edit]
[-] mailx
[edit]
[-] taskset
[edit]
[-] renice
[edit]
[-] xsubpp
[edit]
[-] sg_vpd
[edit]
[-] mail
[edit]
[-] pipewire
[edit]
[-] isql
[edit]
[-] fc
[edit]
[-] semodule_unpackage
[edit]
[-] uniq
[edit]
[-] hexdump
[edit]
[-] eps2eps
[edit]
[-] tset
[edit]
[-] stat
[edit]
[-] nsenter
[edit]
[-] csplit
[edit]
[-] datacopy
[edit]
[-] sudo
[edit]
[-] systemd-escape
[edit]
[-] ssh-keygen
[edit]
[-] garb-systemd
[edit]
[-] gpgconf
[edit]
[-] nl-link-release
[edit]
[-] eqn
[edit]
[-] gc
[edit]
[-] sum
[edit]
[-] sss_ssh_authorizedkeys
[edit]
[-] firewall-cmd
[edit]
[-] icu-config-64
[edit]
[-] xzmore
[edit]
[-] genl-ctrl-list
[edit]
[-] nl-fib-lookup
[edit]
[-] splain
[edit]
[-] nl-list-caches
[edit]
[-] secon
[edit]
[-] sw-engine
[edit]
[-] flatpak-coredumpctl
[edit]
[-] mariadb-dumpslow
[edit]
[-] autoreconf
[edit]
[-] iptc
[edit]
[-] bison
[edit]
[-] mv
[edit]
[-] xxd
[edit]
[-] lsmd
[edit]
[-] x86_64-redhat-linux-gcc-11
[edit]
[-] icuinfo
[edit]
[-] sdiff
[edit]
[-] nohup
[edit]
[-] prune
[edit]
[-] cronnext
[edit]
[-] dc
[edit]
[-] umask
[edit]
[-] xdg-desktop-menu
[edit]
[-] usbhid-dump
[edit]
[-] sha512sum
[edit]
[-] chronyc
[edit]
[-] ulockmgr_server
[edit]
[-] systemd-sysext
[edit]
[-] gcov-tool
[edit]
[-] sg_ident
[edit]
[-] python
[edit]
[-] ssh-keyscan
[edit]
[-] pcre2-config
[edit]
[-] head
[edit]
[-] realpath
[edit]
[-] mariadbd-multi
[edit]
[-] infotocap
[edit]
[-] httxt2dbm
[edit]
[-] findmnt
[edit]
[-] nroff
[edit]
[-] chvt
[edit]
[-] tracepath
[edit]
[-] scsi_ready
[edit]
[-] setpriv
[edit]
[-] cpp
[edit]
[-] host
[edit]
[-] dconf
[edit]
[-] systemd-analyze
[edit]
[-] mysqlaccess
[edit]
[-] diff
[edit]
[-] lsusb
[edit]
[-] dnstap-read
[edit]
[-] coredumpctl
[edit]
[-] troff
[edit]
[-] groff
[edit]
[-] logger
[edit]
[-] gdk-pixbuf-thumbnailer
[edit]
[-] xdg-settings
[edit]
[-] pinky
[edit]
[-] imunify360-command-wrapper
[edit]
[-] ifnames
[edit]
[-] sg_rmsn
[edit]
[-] ea-wappspector
[edit]
[-] canberra-gtk-play
[edit]
[-] lsattr
[edit]
[-] nmtui
[edit]
[-] htdbm
[edit]
[-] sg_emc_trespass
[edit]
[-] fc-query
[edit]
[-] exiv2
[edit]
[-] neqn
[edit]
[-] i386
[edit]
[-] fdp
[edit]
[-] sort
[edit]
[-] fmt
[edit]
[-] gpg-connect-agent
[edit]
[-] team2bond
[edit]
[-] setfattr
[edit]
[-] fold
[edit]
[-] lex
[edit]
[-] firewall-offline-cmd
[edit]
[-] sha384sum
[edit]
[-] git
[edit]
[-] pygettext.py
[edit]
[-] newgrp
[edit]
[-] repodiff
[edit]
[-] man
[edit]
[-] pip3
[edit]
[-] yum-debug-dump
[edit]
[-] infocmp
[edit]
[-] scsi_stop
[edit]
[-] wpctl
[edit]
[-] bootctl
[edit]
[-] sg_decode_sense
[edit]
[-] unexpand
[edit]
[-] chattr
[edit]
[-] openssl
[edit]
[-] dpkg-realpath
[edit]
[-] tsql
[edit]
[-] loadunimap
[edit]
[-] gsdj500
[edit]
[-] strace
[edit]
[-] pango-segmentation
[edit]
[-] lsof
[edit]
[-] snice
[edit]
[-] bno_plot.py
[edit]
[-] ld
[edit]
[-] sha512hmac
[edit]
[-] ulimit
[edit]
[-] gettextize
[edit]
[-] aclocal-1.16
[edit]
[-] uptime
[edit]
[-] gpgme-json
[edit]
[-] pgrep
[edit]
[-] gpgv2
[edit]
[-] semodule_link
[edit]
[-] bzcmp
[edit]
[-] ps2ascii
[edit]
[-] nl-list-sockets
[edit]
[-] 2to3
[edit]
[-] pstree
[edit]
[-] repoquery
[edit]
[-] vimdot
[edit]
[-] flex
[edit]
[-] libpng-config
[edit]
[-] gpg2
[edit]
[-] scsi_temperature
[edit]
[-] mariadb-convert-table-format
[edit]
[-] hardlink
[edit]
[-] loginctl
[edit]
[-] dnf4
[edit]
[-] mysqld_safe
[edit]
[-] nl-link-set
[edit]
[-] mariadb-slap
[edit]
[-] dircolors
[edit]
[-] sieve-dump
[edit]
[-] corepack
[edit]
[-] galera_recovery
[edit]
[-] gst-stats-1.0
[edit]
[-] crlutil
[edit]
[-] strings
[edit]
[-] streamzip
[edit]
[-] sar
[edit]
[-] pygettext3.py
[edit]
[-] yum-builddep
[edit]
[-] crb
[edit]
[-] auvirt
[edit]
[-] gpgtar
[edit]
[-] uname26
[edit]
[-] mariadb-conv
[edit]
[-] yum-groups-manager
[edit]
[-] dmesg
[edit]
[-] mariadb-upgrade
[edit]
[-] nl-route-get
[edit]
[-] pkg-config
[edit]
[-] sg_map26
[edit]
[-] fgconsole
[edit]
[-] mariadbd-safe-helper
[edit]
[-] lesskey
[edit]
[-] ngettext
[edit]
[-] zless
[edit]
[-] ps2ps2
[edit]
[-] mysql_setpermission
[edit]
[-] chage
[edit]
[-] geqn
[edit]
[-] whatis.man-db
[edit]
[-] htpasswd
[edit]
[-] autopoint
[edit]
[-] cpio
[edit]
[-] json_xs
[edit]
[-] mysqldumpslow
[edit]
[-] scsi_start
[edit]
[-] base64
[edit]
[-] pkill
[edit]
[-] mkfifo
[edit]
[-] sxpm
[edit]
[-] convert
[edit]
[-] mysqld_multi
[edit]
[-] ps2pdfwr
[edit]
[-] pw-jack
[edit]
[-] sg_sat_phy_event
[edit]
[-] at
[edit]
[-] compile_et
[edit]
[-] tabs
[edit]
[-] mariadb-admin
[edit]
[-] watch
[edit]
[-] date
[edit]
[-] ipcmk
[edit]
[-] wpexec
[edit]
[-] gvcolor
[edit]
[-] psfxtable
[edit]
[-] pdnsutil
[edit]
[-] egrep
[edit]
[-] vimdiff
[edit]
[-] xmlcatalog
[edit]
[-] nl-link-ifindex2name
[edit]
[-] awk
[edit]
[-] numfmt
[edit]
[-] pyinotify
[edit]
[-] sg_stpg
[edit]
[-] l2ping
[edit]
[-] git-receive-pack
[edit]
[-] iconv
[edit]
[-] ssh-add
[edit]
[-] ed
[edit]
[-] lsns
[edit]
[-] scl_source
[edit]
[-] fc-validate
[edit]
[-] wsrep_sst_rsync_wan
[edit]
[-] chsh
[edit]
[-] procan
[edit]
[-] display
[edit]
[-] dpkg
[edit]
[-] pwmake
[edit]
[-] ea-php80-pear
[edit]
[-] ea-php84-pear
[edit]
[-] fprintd-enroll
[edit]
[-] systemd-delta
[edit]
[-] modulecmd
[edit]
[-] gxl2gv
[edit]
[-] mariadb-setpermission
[edit]
[-] mknod
[edit]
[-] pidof
[edit]
[-] gvgen
[edit]
[-] link
[edit]
[-] gprof
[edit]
[-] znew
[edit]
[-] lneato
[edit]
[-] sfdp
[edit]
[-] systemd-socket-activate
[edit]
[-] hash
[edit]
[-] scl_enabled
[edit]
[-] fc-cache-64
[edit]
[-] instmodsh
[edit]
[-] uuidgen
[edit]
[-] mysqlbinlog
[edit]
[-] dbus-send
[edit]
[-] pfbtopfa
[edit]
[-] chgrp
[edit]
[-] xzdiff
[edit]
[-] nl-qdisc-list
[edit]
[-] dpkg-maintscript-helper
[edit]
[-] gtroff
[edit]
[-] sg_read
[edit]
[-] gst-inspect-1.0
[edit]
[-] ipcs
[edit]
[-] dpkg-trigger
[edit]
[-] gdbmtool
[edit]
[-] mdb_stat
[edit]
[-] fribidi
[edit]
[-] tbl
[edit]
[-] comm
[edit]
[-] glib-compile-schemas
[edit]
[-] word-list-compress
[edit]
[-] ab
[edit]
[-] systemd-sysusers
[edit]
[-] chcon
[edit]
[-] json_pp
[edit]
[-] turbostat
[edit]
[-] zegrep
[edit]
[-] getopts
[edit]
[-] mysqladmin
[edit]
[-] newuidmap
[edit]
[-] nf-exp-list
[edit]
[-] node
[edit]
[-] arping
[edit]
[-] ipcalc
[edit]
[-] upower
[edit]
[-] openvt
[edit]
[-] xmllint
[edit]
[-] kill
[edit]
[-] skill
[edit]
[-] python3.9-x86_64-config
[edit]
[-] setup-nsssysinit
[edit]
[-] gcc-nm
[edit]
[-] psfaddtable
[edit]
[-] needs-restarting
[edit]
[-] zipsplit
[edit]
[-] pmap
[edit]
[-] nl-util-addr
[edit]
[-] grub2-mount
[edit]
[-] btreplay
[edit]
[-] rm
[edit]
[-] fprintd-list
[edit]
[-] localedef
[edit]
[-] htdigest
[edit]
[-] sg_format
[edit]
[-] nl-tctree-list
[edit]
[-] true
[edit]
[-] nf-ct-add
[edit]
[-] bashbug
[edit]
[-] arpaname
[edit]
[-] lessecho
[edit]
[-] unpigz
[edit]
[-] zcmp
[edit]
[-] nl-qdisc-delete
[edit]
[-] ea-php83-pecl
[edit]
[-] gpic
[edit]
[-] osinfo-db-import
[edit]
[-] ccomps
[edit]
[-] xmlwf
[edit]
[-] sg_sanitize
[edit]
[-] gpg-wks-server
[edit]
[-] mariadb-show
[edit]
[-] systemd-tty-ask-password-agent
[edit]
[-] tclsh8.6
[edit]
[-] protoc-c
[edit]
[-] bzmore
[edit]
[-] run-with-aspell
[edit]
[-] lscpu
[edit]
[-] scsi_readcap
[edit]
[-] rpm2cpio
[edit]
[-] reset
[edit]
[-] bzip2
[edit]
[-] m4
[edit]
[-] gst-typefind-1.0
[edit]
[-] rpmkeys
[edit]
[-] setleds
[edit]
[-] unicode_stop
[edit]
[-] dnf
[edit]
[-] nl-route-add
[edit]
[-] addr2line
[edit]
[-] nf-monitor
[edit]
[-] png-fix-itxt
[edit]
[-] orc-bugreport
[edit]
[-] sg_reset
[edit]
[-] grotty
[edit]
[-] pipewire-avb
[edit]
[-] ea-php80-pecl
[edit]
[-] teamnl
[edit]
[-] GET
[edit]
[-] domainname
[edit]
[-] nf-ct-events
[edit]
[-] colrm
[edit]
[-] exempi
[edit]
[-] stty
[edit]
[-] vmstat
[edit]
[-] pkla-check-authorization
[edit]
[-] grub2-editenv
[edit]
[-] zgrep
[edit]
[-] ncurses6-config
[edit]
[-] flatpak-bisect
[edit]
[-] sg_copy_results
[edit]
[-] gpg-wks-client
[edit]
[-] msgfmt
[edit]
[-] tree
[edit]
[-] sg_wr_mode
[edit]
[-] shasum
[edit]
[-] ld.so
[edit]
[-] nl-link-stats
[edit]
[-] top
[edit]
[-] HEAD
[edit]
[-] envsubst
[edit]
[-] xargs
[edit]
[-] dirname
[edit]
[-] crontab
[edit]
[-] chacl
[edit]
[-] json_verify
[edit]
[-] h2xs
[edit]
[-] x86_64
[edit]
[-] imunify360-agent
[edit]
[-] tar
[edit]
[-] netstat
[edit]
[-] perldoc
[edit]
[-] sedispol
[edit]
[-] curl
[edit]
[-] tput
[edit]
[-] pod2man
[edit]
[-] ex
[edit]
[-] ea-php83-pear
[edit]
[-] dig
[edit]
[-] cat
[edit]
[-] getfacl
[edit]
[-] pidstat
[edit]
[-] osql
[edit]
[-] msgexec
[edit]
[-] vdosetuuid
[edit]
[-] manpath
[edit]
[-] bootconfig
[edit]
[-] bluemoon
[edit]
[-] luac
[edit]
[-] corelist
[edit]
[-] pdf2dsc
[edit]
[-] setterm
[edit]
[-] nf-log
[edit]
[-] sim_lsmplugin
[edit]
[-] osinfo-db-path
[edit]
[-] localectl
[edit]
[-] sg_rtpg
[edit]
[-] ea-php83
[edit]
[-] idiag-socket-details
[edit]
[-] sg_luns
[edit]
[-] msgfmt3.9.py
[edit]
[-] less
[edit]
[-] fc-scan
[edit]
[-] test
[edit]
[-] pigz
[edit]
[-] filan
[edit]
[-] pip
[edit]
[-] grub2-file
[edit]
[-] quotasync
[edit]
[-] rsync
[edit]
[-] mariadb-embedded
[edit]
[-] sg_verify
[edit]
[-] mkdir
[edit]
[-] dwz
[edit]
[-] alias
[edit]
[-] stdbuf
[edit]
[-] pwdx
[edit]
[-] automake
[edit]
[-] patchwork
[edit]
[-] grub2-mkrelpath
[edit]
[-] pydoc3.9
[edit]
[-] jobs
[edit]
[-] grub2-mkfont
[edit]
[-] gresource
[edit]
[-] gvpr
[edit]
[-] sg_stream_ctl
[edit]
[-] msgattrib
[edit]
[-] sieve-filter
[edit]
[-] script
[edit]
[-] wsrep_sst_backup
[edit]
[-] xml2-config
[edit]
[-] expand
[edit]
[-] tred
[edit]
[-] sg_write_same
[edit]
[-] xdg-mime
[edit]
[-] getent
[edit]
[-] killall
[edit]
[-] watchgnupg
[edit]
[-] iio_generic_buffer
[edit]
[-] vdir
[edit]
[-] gsoelim
[edit]
[-] cp
[edit]
[-] sg_reset_wp
[edit]
[-] systemd-cgls
[edit]
[-] sg_referrals
[edit]
[-] fc-list
[edit]
[-] base32
[edit]
[-] lua
[edit]
[-] bzless
[edit]
[-] xzless
[edit]
[-] patch
[edit]
[-] mariadb_config
[edit]
[-] b2sum
[edit]
[-] glib-compile-resources
[edit]
[-] systemd-cryptenroll
[edit]
[-] ea-php82
[edit]
[-] basename
[edit]
[-] gtk-query-immodules-2.0-64
[edit]
[-] unicode_start
[edit]
[-] sg_xcopy
[edit]
[-] objcopy
[edit]
[-] nsupdate
[edit]
[-] scsi-rescan
[edit]
[-] nl-addr-delete
[edit]
[-] tzselect
[edit]
[-] event_rpcgen.py
[edit]
[-] post-grohtml
[edit]
[-] mariadb-config
[edit]
[-] mysqlshow
[edit]
[-] perlml
[edit]
[-] libtool
[edit]
[-] gsnd
[edit]
[-] mariadb-service-convert
[edit]
[-] gtester-report
[edit]
[-] nc
[edit]
[-] touch
[edit]
[-] mariadb-check
[edit]
[-] shred
[edit]
[-] dbus-broker
[edit]
[-] mdig
[edit]
[-] dbilogstrip
[edit]
[-] perlivp
[edit]
[-] gzexe
[edit]
[-] graphml2gv
[edit]
[-] gmake
[edit]
[-] tsort
[edit]
[-] peekfd
[edit]
[-] env
[edit]
[-] grub2-mkstandalone
[edit]
[-] distro
[edit]
[-] iio_event_monitor
[edit]
[-] odbcinst
[edit]
[-] gunzip
[edit]
[-] nproc
[edit]
[-] lsinitrd
[edit]
[-] pwscore
[edit]
[-] xzdec
[edit]
[-] sg_rep_pip
[edit]
[-] sg_read_block_limits
[edit]
[-] ls
[edit]
[-] pure-statsdecode
[edit]
[-] kbdrate
[edit]
[-] grub2-kbdcomp
[edit]
[-] git-shell
[edit]
[-] kvm_stat
[edit]
[-] dos2unix
[edit]
[-] sg_turs
[edit]
[-] gpg
[edit]
[-] gv2gml
[edit]
[-] mysqld_safe_helper
[edit]
[-] npm
[edit]
[-] mysql_config
[edit]
[-] pip-3
[edit]
[-] gvmap
[edit]
[-] rpm
[edit]
[-] pod2usage
[edit]
[-] msgfmt3.py
[edit]
[-] nop
[edit]
[-] last
[edit]
[-] mysql
[edit]
[-] deallocvt
[edit]
[-] msql2mysql
[edit]
[-] sg_get_elem_status
[edit]
[-] pidwait
[edit]
[-] grub2-menulst2cfg
[edit]
[-] evmctl
[edit]
[-] lchsh
[edit]
[-] cd
[edit]
[-] dovecot-sysreport
[edit]
[-] aulast
[edit]
[-] groups
[edit]
[-] rescan-scsi-bus.sh
[edit]
[-] gapplication
[edit]
[-] more
[edit]
[-] bsqldb
[edit]
[-] os-prober
[edit]
[-] fc-conflist
[edit]
[-] mm2gv
[edit]
[-] prezip-bin
[edit]
[-] python3.9-config
[edit]
[-] whereis
[edit]
[-] mysqldump
[edit]
[-] make-dummy-cert
[edit]
[-] precat
[edit]
[-] imunify-fgw-dump
[edit]
[-] systemd-hwdb
[edit]
[-] read
[edit]
[-] dot2gxl
[edit]
[-] tclsh
[edit]
[-] pldd
[edit]
[-] [
[edit]
[-] gio
[edit]
[-] btmgmt
[edit]
[-] man.man-db
[edit]
[-] bzegrep
[edit]
[-] POST
[edit]
[-] scsi_mandat
[edit]
[-] x86_energy_perf_policy
[edit]
[-] rvim
[edit]
[-] sed
[edit]
[-] scsi_satl
[edit]
[-] fallocate
[edit]
[-] nl-rule-list
[edit]
[-] updatedb
[edit]
[-] setvtrgb
[edit]
[-] paperconf
[edit]
[-] osinfo-db-export
[edit]
[-] lsirq
[edit]
[-] resolve_stack_dump
[edit]
[-] sg_rep_zones
[edit]
[-] ispell
[edit]
[-] lwp-mirror
[edit]
[-] sginfo
[edit]
[-] glib-gettextize
[edit]
[-] gsf-office-thumbnailer
[edit]
[-] desktop-file-validate
[edit]
[-] diff3
[edit]
[-] cut
[edit]
[-] osinfo-install-script
[edit]
[-] s-nail
[edit]
[-] chrt
[edit]
[-] systemd-creds
[edit]
[-] ypdomainname
[edit]
[-] sg_read_long
[edit]
[-] bzip2recover
[edit]
[-] tr
[edit]
[-] passwd
[edit]
[-] gsdj
[edit]
[-] lslogins
[edit]
[-] fisql
[edit]
[-] mysql_waitpid
[edit]
[-] xdg-screensaver
[edit]
[-] gsbj
[edit]
[-] bcomps
[edit]
[-] perror
[edit]
[-] ln
[edit]
[-] ps2epsi
[edit]
[-] msgen
[edit]
[-] nslookup
[edit]
[-] grops
[edit]
[-] atrm
[edit]
[-] basenc
[edit]
[-] atq
[edit]
[-] prlimit
[edit]
[-] ps2ps
[edit]
[-] zsoelim
[edit]
[-] semodule_package
[edit]
[-] sm3hmac
[edit]
[-] sg_inq
[edit]
[-] nl-cls-delete
[edit]
[-] sg_rbuf
[edit]
[-] teamd
[edit]
[-] btrace
[edit]
[-] who
[edit]
[-] gtar
[edit]
[-] audit2why
[edit]
[-] dracut
[edit]
[-] ptardiff
[edit]
[-] kmod
[edit]
[-] apropos
[edit]
[-] gtk-query-immodules-3.0-64
[edit]
[-] join
[edit]
[-] tracker3
[edit]
[-] sg_write_verify
[edit]
[-] gpio-event-mon
[edit]
[-] pslog
[edit]
[-] socat
[edit]
[-] prove
[edit]
[-] systemd-path
[edit]
[-] sg_opcodes
[edit]
[-] sg_ses
[edit]
[-] mesg
[edit]
[-] dbus-broker-launch
[edit]
[-] timedatectl
[edit]
[-] xzcmp
[edit]
[-] setfont
[edit]
[-] nl-pktloc-lookup
[edit]
[-] ssh-agent
[edit]
[-] sha256hmac
[edit]
[-] xdg-open
[edit]
[-] aulastlog
[edit]
[-] printf
[edit]
[-] nl-cls-add
[edit]
[-] ncursesw6-config
[edit]
[-] apropos.man-db
[edit]
[-] elfedit
[edit]
[-] gpg-error
[edit]
[-] mapscrn
[edit]
[-] tcptraceroute
[edit]
[-] update-gtk-immodules
[edit]
[-] debuginfo-install
[edit]
[-] cvtsudoers
[edit]
[-] su
[edit]
[-] iostat
[edit]
[-] sg_scan
[edit]
[-] vdodmeventd
[edit]
[-] pdns_control
[edit]
[-] mktemp
[edit]
[-] dd
[edit]
[-] mariadb-access
[edit]
[-] msgcat
[edit]
[-] umount
[edit]
[-] dpkg-query
[edit]
[-] du
[edit]
[-] chmem
[edit]
[-] sg_readcap
[edit]
[-] zipgrep
[edit]
[-] c99
[edit]
[-] sg_modes
[edit]
[-] ea-php80
[edit]
[-] prtstat
[edit]
[-] fusermount
[edit]
[-] wdctl
[edit]
[-] imunify-service
[edit]
[-] vim
[edit]
[-] gpio-hammer
[edit]
[-] gobject-query
[edit]
[-] dot
[edit]
[-] showconsolefont
[edit]
[-] rename
[edit]
[-] nl-monitor
[edit]
[-] wsrep_sst_common
[edit]
[-] traceroute6
[edit]
[-] mariadb-secure-installation
[edit]
[-] cpapi1
[edit]
[-] x86_64-redhat-linux-gnu-pkg-config
[edit]
[-] cpapi3
[edit]
[-] ea-php82-pear
[edit]
[-] rpcbind
[edit]
[-] paste
[edit]
[-] readelf
[edit]
[-] x86_64-redhat-linux-c++
[edit]
[-] sg_prevent
[edit]
[-] replace
[edit]
[-] gst-launch-1.0
[edit]
[-] dltest
[edit]
[-] pure-pw
[edit]
[-] ps
[edit]
[-] my_print_defaults
[edit]
[-] git-upload-archive
[edit]
[-] chmod
[edit]
[-] systemd-notify
[edit]
[-] systemd-cgtop
[edit]
[-] nl-link-enslave
[edit]
[-] bsqlodbc
[edit]
[-] loadkeys
[edit]
[-] twopi
[edit]
[-] timeout
[edit]
[-] desktop-file-install
[edit]
[-] xz
[edit]
[-] irqtop
[edit]
[-] pipewire-vulkan
[edit]
[-] hex2hcd
[edit]
[-] mariadb-install-db
[edit]
[-] diffimg
[edit]
[-] preunzip
[edit]
[-] getopt
[edit]
[-] whatis
[edit]
[-] uuidparse
[edit]
[-] ea-php82-pecl
[edit]
[-] locale
[edit]
[-] repoclosure
[edit]
[-] pkcheck
[edit]
[-] mysql_tzinfo_to_sql
[edit]
[-] compare
[edit]
[-] cluster
[edit]
[-] vi
[edit]
[-] gtbl
[edit]
[-] sedismod
[edit]
[-] fips-finish-install
[edit]
[-] pwd
[edit]
[-] tty
[edit]
[-] avinfo
[edit]
[-] lsusb.py
[edit]
[-] sha1hmac
[edit]
[-] setarch
[edit]
[-] dirmngr-client
[edit]
[-] ssltap
[edit]
[-] logresolve
[edit]
[-] btt
[edit]
[-] sg_senddiag
[edit]
[-] nl-neigh-delete
[edit]
[-] c++filt
[edit]
[-] ima-add-sigs
[edit]
[-] ssh
[edit]
[-] rsync-ssl
[edit]
[-] sudoedit
[edit]
[-] pstree.x11
[edit]
[-] gettext
[edit]
[-] sg_get_lba_status
[edit]
[-] wmf2x
[edit]
[-] pygettext3.9.py
[edit]
[-] sg_requests
[edit]
[-] mariadbd-safe
[edit]
[-] config_data
[edit]
[-] rpm2archive
[edit]
[-] lwp-request
[edit]
[-] kbd_mode
[edit]
[-] zipinfo
[edit]
[-] lefty
[edit]
[-] fgrep
[edit]
[-] x86_64-redhat-linux-g++
[edit]
[-] pathfix3.9.py
[edit]
[-] wait
[edit]
[-] pathfix.py
[edit]
[-] ionice
[edit]
[-] vdoformat
[edit]
[-] vdostats
[edit]
[-] as
[edit]
[-] python3-html2text
[edit]
[-] desktop-file-edit
[edit]
[-] attr
[edit]
[-] ac
[edit]
[-] scsi_logging_level
[edit]
[-] wmf2eps
[edit]
[-] pkaction
[edit]
[-] idn
[edit]
[-] g13
[edit]
[-] fprintd-verify
[edit]
[-] gpg-agent
[edit]
[-] lsmcli
[edit]
[-] wmf2gd
[edit]
[-] pod2text
[edit]
[-] ftp
[edit]
[-] nl-neigh-add
[edit]
[-] mysqlcheck
[edit]